unit interpreteur;

{ $DEFINE PILOTAGE }
{$DEFINE TRAITEMENT }

{ jour le 30/10/00}
{ 17/11/00 (E.Leymarie) ajout de fonctions pour le comptage deux D et la RMN :  }
{- delay[t] : pause de t seconde dans l'excution du batch                       }
{- acqsimple2D[TT, "wait"] : dmarre une acquisition neutron 2D de TT secondes. Si le deuxime champs est wait, l'interpreteur attend la fin de l'acquisition avant de passer  la ligne suivante.
{- testacqsimple2D : test la fin de l'acquisition acqsimple2D. la variable acq2d de l'interpreteur est initialise  1 si l'acquisition est encore en cours et  0 si elle est termine.
{- RMNsaturation[t] : dmarre une saturation de t ms. L'interpreteur est bloqu pendant la saturation.
{- RMNlitpolar[npassages] : lit la polarisation nuclaire en npassages. Place le rsultat dans les variables temps et polar de l'interpreteur.
{- RMNavecBase["true"] : permet de faire des spectres RMN avec ou sans signal de base.
{- Addpol[x,y] : ajoute un point dont les coordonnes sont les variables x et y de l'interpreteur dans la fentre visupol.
{- Clearvisupol : permet de rinitialiser visupol
{ Modification de interpreteurform.Timer1Timer pour arrter l'interpreteur pendant une acquisition 2d ou RMN
{ Ajout de nouvelles variables dans l'interpreteur :                            }
{	Variables RMN (si RMNacqui existe) : polar et temps.                    }
{	Variable acquisition 2D (si comptage2D existe) : acq2d.                 }
{ 13.12.00 : FO : ajout d'une procdure lecture spectre, ligne 192              }
{              ReadSpectre1D et ReadSpectre2D                                   }
{              nouvelle procdure AcqSimplePSD                                  }
{              nouveau flag FlagWaitAcquisPSD                                   }
{ 10.01.01 : FO : procedure pour fixer le courant dans la BOSS508               }
{              il manque une initialisation qqe part                            }
{              la BOSS n'accepte pas une rafale de commandes                    }
{ 26.01.01 : FO : setFieldL, pilotage de la bobine supra                        }
{ 02.02.01 : FO : fonctionnement du bouton "continue" corrig A TESTER !!!      }
{ 15.02.01 : FO : ajout d'une directive de compilation pour qu'on puisse utiliser traitement sans trainer toutes les units du programme de pilotage }
{               $DEFINE PILOTAGE                                                }
{               $DEFINE TRAITEMENT                                              }
{ 14.03.01 : FO : ajout de quelques fonctions de base Scal2D, Add2D, Sub2D      }
{                 delSpectre2D, saveToASCII2D                                   }
{ 15.03.01 : CL :ajout des autres fonctions de base MultSpect, DivSpect, ScalAddSpect, }
{               ScalSubSpect, ScalMultSpect,ScalDivSpect                        }
{ 27.03.01 : EL :Modifications suite au couplage Traitement/pilotage:           }
{                L 297: ajout du 3eme parametre a addspectre,                   }
{                L 323: idem pour addpt,                                        }
{                L 61: ajout de graph2D dans les USES pilotage,                 }
{ 03.04.01 : FO : nouvelles procdures                                          }
{                   function SetX2D:integer;far;   function SetY2D:integer;far; }
{                   function Concat1D;                                          }
{                   function Remap2DtoQxQz:integer;far                          }
{ 06.06.01 : FO : ajout des procdures SetCurrentFXY pour le reglage automatique des flippers }
{ 12.06.06 : EL : ajout setExpCond et SetComment                                }
{ 15.06.01 : EL : nouvelle fonction SommeDNPA pour somme petits angles exacte   }
{ 9.07.01 : EL : nouvelle fonction masquesecteur                                }
{ 10.07.01 : EL : - Cration de openspectre qui permet d'ouvrir un spectre au nouveau format}
{                 - Cration de NormMoniSpectre2D qui normalise le moniteur d'un spectre 2D }
{ 16.07.01 : EL : Modification de la procedure traitstring pour utilisation du parametre string des variables }
{                 effet - les tableaux pars et par sont rinitialiss avant chaque instruction, }
{                        - en cas d'utilisation de variable, le parametre pars[i] est initialis  la valeur de la variable et non a son nom comme precedement }
{                       - pour toute fonction, pars[i]=nom$ entraine l'initialisation pars[i]:=nom.p4     (le caractere # devient reserve) }
{                       - pour toute fonction, pars[i]=@nom entraine l'initialisation pars[i]:=nom    (le caractere @ devient reserve)  }
{                 cration de setstring. permet d'initialiser la valeur de p4   }
{16.07.01 : EL : Cration de variables type tableau                             }
{                - cration du parametre tvaripar.p5 array of real              }
{                - cration de la fonction settab[@nom,indice,value1,value2,...]  pour initialiser 7 elements du tableau nom}
{                - modification de la procedure traitstring :                   }
{                  l'utilisation de nom#expression entraine par[i]=nom.p5[expression]}
{18.07.01 : EL : Netoyage divers                                                }
{20.09.01 : EL : plus nouvelles procedures StartPolAlt,initTOF,startTOF,ReadDataTOF,RMNirrad }
{                 modification de acqsimple2D,testacqsimple2D,addcomment et de la procedure ScriptStopButtonClick pour inclure PAPOL }
{21.09.01 : EL: modification des procedures savetoASCII                         }
{30.10.01 : FO : mise a jour de la position de dpart de la fenetre dans FormCreate }
{07.12.01 : EL : Mise a jour de la procedure Spectre3DTo2D                      }
{08.02.02 : EL : Ajout de la fonction OpenPaxy                                  }
{ 30.03.02 : FO : nouvelle fonction concat2D pour concatener 2 spectres 2D (ayant des coordonnes diffrentes) }
{ 31.02.02 : FO : ajout de deux fonctions appendRow et appendCol                }
{                 in : "Monspectre2D" et "MonSpectre1D", abscisses en pixels !! }
{ 02.04.02 : FO : nouvelle fonction : Extract2D["ACUP", xmin, ymin, xmax, ymax, "toto"] }
{ 05.04.02 : FO : nouvelle fonction racine carre "sqrt1D" et "sqrt2D"          }
{                 pour calculer les barres d'erreurs                            }
{ 08.04.02 : FO : nouvelle fonction de moyenne glissante "smooth1D"             }
{                 <smooth1D> "spectrein" "nbr de points de moyenne" IMPAIR!, "spectre out" }
{ 02.10.02 : TDD: fonction Resize1D pour redimensionner la taille du spectre 1D }
{                 fonction Convert1Dto2DrowY, idem Convert1Dto2DRow avec le choix de y}
{                 fonction Convert1Dto2DcolX, idem Convert1Dto2DCol avec le choix de y}
{                 fonction AppendRowY, AppendColX ,idem AppendRow avec le choix de y  }
{ 08.12.02 : Fo : nouvelle fonction "SommeCirculaireSpectre2D"                  }
{ 16.04.03 : FO : nouveau traitement es paramtres des functions de l'ionterprteur }
{                 les chaines peuvent maintenant contenir les caractres ',' et '=' }
{version A JOUR le 25.09.01                                                     }
{ ============================================================================= }
{ A FAIRE                                                                       }
{ documenter les functions : INPUT; OUTPUT, IMPLICIT CHANGES                    }
{ * les arguments de SaveSpectre sont dans un ordre douteux                     }
{ * pourquoi addpt peut-il marcher avec des spectres 2D ?                       }
{ * FAIRE UN SYNTAXE CHEKCKER SUR LE PARSER ET AMELIORER LA GESTION DES ERREURS }
{ * update des combo aprs les calculs                                          }
{ * mettre a jour la liste des fonctions disponibles                            }
{ * procdures pour les calculs sur les spectres 1D                             }
{   toujours definir les types des data dans les spectres 2D i.e. au moins "='raw' !!! }
{ * IL FAUT DES MESSAGES D'ERRUEURS pour les I/O sur le disque                  }
{   sinon on ne sait pas ce qui se passe                                        }
{ * quand on fait des copier-coller dans le parser ca marche mal en general     }

interface

{$IFDEF PILOTAGE }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, multimemo, Parser10, StdCtrls, Menus, Db, DBTables,editdata, boss508, ips12010,graph2D,
  JvComponent, JvFormPlace;
{$ENDIF }

{$IFDEF TRAITEMENT }
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, multimemo, Parser10, StdCtrls, Menus, Db, DBTables, editdata,graph2D, JvComponent, JvFormPlace, GPIB_CEC, EuroPSD;
{$ENDIF }

const
repseq='c:\sequences\';
seqext='.seq';
wm_redessine=$403+wm_user;
MaxPara =10; { nombre maximum de paramtres dans les fonctions de l'interprteur }
type
EvarError = class(Exception);

type
tvaripar = class(tobject)
       public
       value:extended;
       p1:integer;
       p2:double;
       p3:double;
       p4: string;
       p5: array of real;
end;
type
  Tinterpreteurform = class(TForm)
    Panel1: TPanel;
    Parser1: TParser;
    ScriptExecuteButton: TButton;
    Timer1: TTimer;
    ScriptExecuteSelectionButton: TButton;
    ScriptStopButton: TButton;
    Panel2: TPanel;
    Edit1: TEdit;
    Label1: TLabel;
    mem1: tmultimemo;
    MainMenu1: TMainMenu;
    suividevariable1: TMenuItem;
    variables1: TMenuItem;
    fonctions1: TMenuItem;
    ContinueButton: TButton;
    Tablemot: TTable;
    DataSourcemot: TDataSource;
    TablemotIndex: TIntegerField;
    TablemotZero: TIntegerField;
    TablemotDepart: TIntegerField;
    TablemotFin: TIntegerField;
    TablemotInc: TIntegerField;
    TablemotNomcourt: TStringField;
    TablemotAutorisation: TIntegerField;
    fonctionsmathmatiques1: TMenuItem;
    fonctionsduprogramme1: TMenuItem;
    ScriptStatus: TLabel;
    Parser2: TMenuItem;
    JvFormPlace1: TJvFormPlace;
    procedure FormCreate(Sender: TObject);
    procedure ScriptExecuteButtonClick(Sender: TObject);
    procedure ScriptExecuteSelectionButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure suividevariable1Click(Sender: TObject);
    procedure ScriptStopButtonClick(Sender: TObject);
    procedure ContinueButtonClick(Sender: TObject);
    procedure variables1Click(Sender: TObject);
    procedure fonctions1Click(Sender: TObject);
    procedure Parser1ParserError(Sender: TObject; E: Exception);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Dclarations prives}
    filename:string;
    actlig,actligf:tstringlist; {tableau des ordres  effectuer}
    procedure addmotorlist;
    procedure pretraitement;
    procedure execution;
    function traitstring(s:string;ind:integer):integer;
   public
    { Dclarations publiques}

    seqencours:integer;{sequence en cours}
    procedure addvariable(name:string;value:integer;p1:integer;p2:double;p3:double;p4:string;tpro:tobject);
    procedure setvaleur(name:string;value:integer);
    procedure executeseq(name:string);
 end;

var
  interpreteurform: Tinterpreteurform;

implementation
{$IFDEF PILOTAGE }
uses suividesvariables, variablesliste, functionsliste,interfaceMoteurs, SuiviAcquisitionPRISM,
  PilotageManipMainForm, BoiteNoire, comptage2D, operations, gpib_CEC, RMNbases,
  RMNacquisition, visu_polarisation, ComptageTests, comptage2DTOF;
{$ENDIF }
{$IFDEF TRAITEMENT }
uses suividesvariables, variablesliste, functionsliste, BoiteNoire;
{$ENDIF }


var
  ordre,variable,varpar,labels:tstringlist;
  par:array[1..maxPara] of extended;
  pars:array[1..maxPara] of  string;
  param:array[0..200] of tvaripar;
  labelstab:array[0..26] of integer;
  seqon,seqlig:integer;
  flagwaitchamp,flagwaittemp:boolean;
  flagwaitacquis,flagwaitmotor:boolean;
  flagwaitacquisPSD:boolean;
  flagWaitEnergizing:boolean; { flag qui indique que l'on est en train d'energiser la bobine supra }
  CurrentValue:double; { valeur actuelle du courant }
{ =================================================================== }
{ A cet endroit se crent toutes les fonctions
destines  appeler les diffrentes routines}



{********************************************* }
{ fonctions de bases de l'interpreteur}
{********************************************* }
    function min(a,b:double):double;
    begin
     if a<b then result:=a else result:=b;
    end;

    function max(a,b:double):double;
    begin
     if a>b then result:=a else result:=b;
    end;

    function rien(s:string):integer; far;
    begin
    result:=0;
    end;

    function delay:integer;far; {stop l'execution du timer1 pendant par[1] seconde}
    var t0,t,temps:real;
    begin
    interpreteurform.timer1.enabled:=false;
    t0:=(time-int(time))*86400;  {temps en s}
    temps:=par[1];
    repeat
      t:=(time-int(time))*86400;
      if t<t0 then t:=t+86400;  {correction bug passage par minuit}
      Application.processMessages;
    until ((t-t0)>temps);
    result:=0;
    interpreteurform.timer1.enabled:=true;
    end;

    {fonctions boite noire}
    function addcomment:integer;far;
    var
    s:string;
    begin
    s:=pars[1]+pars[2]+pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
    boitnoir.receivetext(s);
    result:=1;
    end;

    {fonction permettant d'initialiser le parametre p4 de la variable pars[1] }
    {cette fonction concat l'ensemble des elements de pars (sauf le premier}
    { INPUT: pars[1] : nom de la variable (entre en @nom)
             pars[2..10] : lments concatenes
    {OUPUT : le parametre p4 de la variable nom}
    function Setstring:integer;far;
    var temp:string;
        i:integer;
    begin
    temp:='';
    for i:=2 to 10 do
        temp:=temp+pars[i];
        param[variable.indexof(pars[1])].p4:=temp;
    end;

    {fonction permettant d'initialiser le tableau p5 de la variable pars[1] }
    { INPUT: pars[1] : nom de la variable (entre en @nom),
             par[2] : indice de dpart,
             par[3],..., par[10]: valeur
    {OUPUT : les parametres p5[par[2]],...,p5[par[2]+7] de la variable pars[1]}
    function Settab:integer;far;
    var vind:integer;
        i:integer;
    begin
    vind:=variable.indexof(pars[1]);
    for i:=0 to 7 do
        if pars[3+i]<>'' then
        begin
        {verification taille }
        if length(param[vind].p5)<(round(par[2])+i+1 ) then setlength(param[vind].p5,round(par[2])+i+1);
        {affectation}
        param[vind].p5[round(par[2])+i]:=par[i+3];
        end;
    end;

    {ajoute un point  un graph}
    {par[1]=1 ou 2 :dim
     pars[2] Nom du spectre
     par[3],par[4],par[5],par[6],par[7] : x,y,lt,z,mon}
    function addpt:integer;far;
    begin
    if par[1]=1 then und.addpt(pars[2],par[3],par[4],par[5],par[6],par[7]);
    if par[1]=2 then deuxd.addpt(pars[2],par[3],par[4],par[5],par[6],par[7]);
    if par[1]=3 then troisd.addpt(pars[2],par[3],par[4],par[5],par[6],par[7]);
    result:=1;
    {$IFDEF PILOTAGE }
    sendmessage(principalform.handle,wm_redessine,0,0);
    {$ENDIF }
    {$IFDEF TRAITEMENT }
    {sendmessage(TraitementMainForm.handle,wm_redessine,0,0);  }
    {$ENDIF }
    end;

    {ajoute un point  un spectre 1D}
    {pars[1] Nom du spectre
     par[2],par[3],par[4] : x,z,mon}
    function addpoint1D:integer;far;
    begin
       und.addpt(pars[1],par[2],0,0,par[3],par[4]);
       result:=1;
       {$IFDEF PILOTAGE }
       sendmessage(principalform.handle,wm_redessine,0,0);
       {$ENDIF }
       {$IFDEF TRAITEMENT }
       {sendmessage(TraitementMainForm.handle,wm_redessine,0,0);  }
       {$ENDIF }
    end;

{********************************************* }
{debut de la partie propre  PILOTAGE}
{********************************************* }
{$IFDEF PILOTAGE }

{ ============================================== }
{ lecture/ecriture bas niveau sur la carte GPIB  }

{ initialisation de la carte GPIB }
{ adresse code en dur  0        }
  function IEInit:integer;far
  begin
     GPIBinitialize(0,0);
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], command as string }
{         pars[3]; answer as string  }
{         par[4]; status as long     }
  function Launch:integer;far
  var s:string;
  begin
     GPIBSend(par[1],pars[2]);
     GPIBRead(par[1],s,255);
     { il faut mettre la variable de retour a jour ou ie_answer }
     { ainsi que ie_status = gpibstatus }
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], command as string }
{         par[3]; nbr of expected bytes 'ie_expectedbytes' }
{         par[4]; nbr of received bytes 'ie_transmittedbytes' }
  function IEGetLongArray:integer;far
  var s:string;
  begin
     GPIBSend(par[1],pars[2]);
     rarray32b(var d; count : longint; var len : longint; var status : longint);
     { il faut mettre la variable de retour a jour ou ie_answer }
     { ainsi que ie_status = gpibstatus }
     { ou on met le tableau lu??? }
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], command as string }
{         par[3]; nbr of expected bytes 'ie_expectedbytes' }
{         par[4]; nbr of received bytes 'ie_transmittedbytes' }
  function IESendLongArray:integer;far
  var s:string;
  begin
     GPIBSend(par[1],pars[2]);
     rarray32b(var d; count : longint; var len : longint; var status : longint);
     { il faut mettre la variable de retour a jour ou ie_answer }
     { ainsi que ie_status = gpibstatus }
     { on envoie quel tableu ??? }
  end;


    function fixtimer(s:string):integer; far;
    var
    i:extended;
    begin
    i:=param[variable.indexof(s)].value;
    if i=0 then
    interpreteurform.timer1.enabled:=false else
    interpreteurform.timer1.interval:=round(i);
    result:=0;
    end;
{fonction associes aux variables moteurs}
    function movabs(s:string):integer; far;
    begin
    result:=0;
    end;

    function settable(s:string):integer; far;
    var
    i:integer;
    begin
    i:=variable.indexof(s);
    if tabmot<>nil then tabmot.setval((param[i].p1),round(param[i].p2),round(param[i].value));
    result:=0;
    end;


{fonctions d'attente}


    function waitchamp:integer;far;
    begin
    flagwaitchamp:=true;
    result:=0;
    end;

    function waittemp:integer;far;
    begin
    flagwaittemp:=true;
    result:=0;
    end;

    function pause:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    result:=0;
    end;

    function waitmotors:integer;far;
    begin
    if tabmot<>nil then flagwaitmotor:=true;
    result:=0;
    end;

{fonction acquisition PRISM}

    function acqsimple:integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.acqsimple(par[1],par[2],par[3],par[4]);
    result:=1;
    flagwaitacquis:=true;
    end;

    function acqsimplePSD:integer; far;
    begin
    if comptage<>nil then comptage.lancementComptage(pars[1],par[2],par[3],par[4],par[5]);
    result:=1;
    flagwaitacquisPSD:=true;
    end;
    function addcond:integer;far;
    var
    s:string;
    begin
    if suiviPRISMForm<>nil then begin
    s:=pars[1]+' polar :'+suiviPRISMForm.getpolar;
    boitnoir.receivetext(s);
    end;
    result:=1;
    end;

{fonction acquisition PAPOL}

    {permet de lancer un comptage en polarisation alterne
    INPUT par[1] temps total en s,
          par[2] dure d'une alternance UP en s,
          par[3] dure d'une alternace down en s}
    function StartPolAlt:integer; far;
    begin
    interpreteurform.timer1.enabled:=false;
    operationform.LancerPolAlter(par[1],par[2],par[3]);
    interpreteurform.timer1.enabled:=true;
    end;
    {lance une acquisition simple 2D de par[1] seconde, si pars[2]='wait' l'interpreteur attend la fin de
    l'acquisition pour passer  l'instruction suivante}
    function acqsimple2D:integer; far;
    begin
    interpreteurform.timer1.enabled:=false;
       if (comptage2Dform<>nil) then
          if not(comptage2DForm.testacquis) then comptage2Dform.acquisitionSimple2D(round(par[1]));
       if (comptage2DTOFform<>nil) then
          if not(comptage2DTOFform.testacquis) then comptage2DTOFform.acquisitionSimple2D(round(par[1]));
       if pars[2]='wait' then flagwaitacquis:=true else flagwaitacquis:=false;
       result:=1;
       interpreteurform.timer1.enabled:=true;
    end;

    {test la fin de l'acquisition 2D et charge la variable acq2d
    acq2d=1 l'acquisition est en cours}
    function testacqsimple2D:integer; far;

    begin
       if (comptage2Dform<>nil) then
          if (comptage2DForm.testacquis) then
            interpreteurform.parser1.setvariable('acq2d',1)
            else
            interpreteurform.parser1.setvariable('acq2d',0);
       if (comptage2DTOFform<>nil) then
          if (comptage2DTOFForm.testacquis) then
            interpreteurform.parser1.setvariable('acq2d',1)
            else
            interpreteurform.parser1.setvariable('acq2d',0);
    result:=1;
    end;
{fonctions d'acquisition TOF pour PAPOL}
    {initialisation TOF}
    function initTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.intitialisationTOF;
    interpreteurform.timer1.enabled:=true;
    end;
    {permet de synchroniser le comptage sur une alternance UP du comptage}
    function startTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.startTOF;
    interpreteurform.timer1.enabled:=true;
    end;
    {permet de lire les data TOF en cours de comptage}
    function readdataTOF:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if (comptage2DTOFform<>nil) then comptage2DTOFform.readdataTOF;
    interpreteurform.timer1.enabled:=true;
    end;
    function addangles:integer;far;
    begin
    if tabmot<>nil then tabmot.ecritangles;
    result:=1;
    end;

{fonctions Annexes PRISM}
    function fixtemps(s:string):integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixtemps(round(param[variable.indexof(s)].value));
    result:=0;
    end;

    function comptcond(s:string):integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.comptcond(param[variable.indexof(s)].p1,round(param[variable.indexof(s)].value));
    result:=0;
    end;

    function fixflip(s:string):integer; far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixflip(pars[1]);
    result:=0;
    end;

    function polarisation:integer;far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixpolar(pars[1]);
    result:=1;
    end;

    function fixcompt:integer;far;
    begin
    if suiviPRISMForm<>nil then suiviPRISMForm.fixcompt(pars[1]);
    result:=1;
    end;

{ fonctions RMN PAPOL}
    {modification du synthe
    INPUT: par[1] frequence centrale en MHz
           par[2] amplitude de modulation en kHz
           par[3] nivau en dBm
           pars[4] :F1,F2,...,F6}
    function RMNirrad:integer;far;
    begin
    if RMNbase<>nil then
       begin
       RMNbase.initirrad(par[1],par[2],par[3],pars[4]);
       end;
    end;
    {entraine une saturation RMN de par[1] ms, le timer de l'interpreteur est bloqu}
    function RMNsaturation:integer;far;
    begin
    if RMNbase<>nil then
       begin
       interpreteurform.timer1.enabled:=false;
       RMNbase.synthe_sature(par[1]);
       interpreteurform.timer1.enabled:=true;
       end;
    result:=1;
    end;

    {lit la polarisation conformement au choix de la fiche (sauf nombre de passage) RMNacqui et transfert dans les variables temps et polar}
    function RMNlitpolar:integer;far;
    var pol,t:real;
    begin
    interpreteurform.timer1.enabled:=false;
    if RMNacqui<>nil then RMNacqui.mesurepolar(round(par[1]),pol,t);
    interpreteurform.parser1.setvariable('temps',t);
    interpreteurform.parser1.setvariable('polar',pol);
    result:=1;
    interpreteurform.timer1.enabled:=true;
    end;

    {permet de faire un acquisition RMN avec ou sans prise du signal de base}
    function RMNavecBase:integer;far;
    begin
    if RMNacqui<>nil then RMNacqui.base.checked:=(pars[1]='true');
    result:=1;
    end;

    {permet d'ajouter un point visupol}
    function addpol:integer;far;

    begin
    if visupol<>nil then visupol.ajoute(par[1],par[2]);
    end;

    {permet de rinitialiser visupol}
    function clearvisupol:integer;far;
    begin
       if visupol<>nil then visupol.clearvisu;
    end;

{ =============================================== }
{ fonctions de pilotage de courants et de tension }

    {utilisable avec la source de courant Keythley 195 }
    function setcurrent:integer;far;
    var
      buf: packed array[0..50] of char; {* R/W buffer.*}
      buffer:string[50];
      adresseK220:integer;
    begin
       adresseK220:=12;
       buf := 'F0X'+#13#10;
       GPIBSend(AdresseK220,buf);
       buf := 'I9.5E-8X'+#13#10;
       GPIBSend(AdresseK220,buf);
       buf := 'D0X'+#13#10;
       GPIBSend(AdresseK220,buf);
       buf := 'V001X'+#13#10;
       GPIBsend(AdresseK220,buf);
    { I on }
      buf := 'F0X'+#13#10;
      gpibsend(12,buf);
    { set le courant }
      currentValue:=strToFloat(pars[1]);
      buffer := 'I'+formatfloat('#.###E-0',currentValue)+'X'+#13#10;
      strpcopy(buf,buffer);
      gpibsend(12,buf);
    { I off }
      buf := 'F1X'+#13#10;
      gpibsend(12,buf);
      result:=1;
    end;

    { utilisable avec le voltmtre AOIP MN5140 }
    function getvoltage:integer;far;
    var s,S1:string;
    begin
    gpibsend(25,'Moy ?');
    gpibread(25,s,255);
    { sauvegarde des data dans la boite noire }
    s1:='Multimetre : '+#9+s;
    boitnoir.receivetext(s1);
    result:=1;
    end;

    {fonction de commande directe de l'alim Boss}
    function fixIboss:integer;far;
    begin
    SetCourant_BOSS508(7,par[1]);
    end;

   { pilotage de l'alimentation bobine supra Oxford }
   { on fixe le champ longitudinal                  }
   { INPUT: le champ en teslas                      }
   { OUTPUT: l'alim dmarre la squence pour changer le champ }
    function SetFieldL:integer;far;
    begin
    { a terme, il faudra passer par operations }
         SetField_IPS12010(25,par[1]);
    { il faut attendre que toute la squence d'nergisation et de denegrisaion soit finie }
    { ca dure quand meme 1 minute avec les sweep inclus                                    }
         flagWaitEnergizing:=true;
    end;

{ pilotage des courants dans les flippers }
    function SetCurrentF1H:integer;far;
    begin
        OperationForm.SetCourantFlipper1H(par[1]);
    end;
    function SetCurrentF1V:integer;far;
    begin
        OperationForm.SetCourantFlipper1V(par[1]);
    end;
    function SetCurrentF2H:integer;far;
    begin
        OperationForm.SetCourantFlipper2H(par[1]);
    end;
    function SetCurrentF2V:integer;far;
    begin
        OperationForm.SetCourantFlipper2V(par[1]);
    end;


{$ENDIF }
{********************************************* }
{fin de la partie propre  PILOTAGE}
{********************************************* }

{ ======================================================================= }
{fonction gnrales sur les spectres }

    {fonction permettant de modifier les conditions experimentalles d'un spectre
    INPUT par[1] 1:und ,2:deuxd, 3:3d
          pars[2]:nom du spectre
          pars[3]:nom de la condition experimentalle
          par[4]:valeur de la condition}

    function SetExpCond:integer;far;
    var vind:integer;
    begin
    if par[1]=1 then
       begin
       vind:=und.indexof(pars[2]);
       if vind<>-1 then
       und.spect[vind].SetExpCond(pars[3],par[4]);
       end;
    if par[1]=2 then
       begin
       vind:=deuxd.indexof(pars[2]);
       if vind<>-1 then
       deuxd.spect[vind].SetExpCond(pars[3],par[4]);
       end;
    if par[1]=3 then
       begin
       vind:=troisd.indexof(pars[2]);
       if vind<>-1 then
       troisd.spect[vind].SetExpCond(pars[3],par[4]);
       end;
    end;
    {fonction permettant de modifier le commentaire d'un spectre
    INPUT par[1] 1:und ,2:deuxd, 3:3d
          pars[2]:nom du spectre
          pars[3],..,par[10]:commentaire}
    function SetComment:integer;far;
    var vind:integer;
    begin
    if par[1]=1 then
       begin
       vind:=und.indexof(pars[2]);
       if vind<>-1 then
       und.spect[vind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
       end;
    if par[1]=2 then
       begin
       vind:=deuxd.indexof(pars[2]);
       if vind<>-1 then
       deuxd.spect[vind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
       end;
    if par[1]=3 then
       begin
       vind:=troisd.indexof(pars[2]);
       if vind<>-1 then
       troisd.spect[vind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
       end;
    end;

    {mise a Zero d'un spectre}
    {par[1]=1,2,3 dim; pars[2] : nom du spectre}
    function clearspectre:integer;far;
    begin
    if par[1]=1 then und.clear(pars[2]);
    if par[1]=2 then deuxd.clear(pars[2]);
    if par[1]=3 then troisd.clear(pars[2]);
    result:=1;
    end;
    {permet de crer un spectre en mmoire vive}
    {par[1] =1,2,3 Dim du spectre,
     pars[2] nom du spectre,
     par[3],par[4],par[5] dim X,Y,LT  }
    function addspectre:integer;far;
    begin
    if par[1]=1 then und.addspectre(pars[2],round(par[3]),round(par[4]),round(par[5]));
    if par[1]=2 then deuxd.addspectre(pars[2],round(par[3]),round(par[4]),round(par[5]));
    if par[1]=3 then troisd.addspectre(pars[2],round(par[3]),round(par[4]),round(par[5]));
    result:=1;
    end;


{ ======================================================================= }
{ fonctions de lecture/ecriture de spectres }

    { lecture d'un spectre sauv sur le disque (ancien format)}
    { A MODIFIER OU SUPPRIMER }
    { INPUT: nom fichier du spectre}
    { OUTPUT: le spectre est transfr dans spect[1] }
    function readspectre1D:integer;far;
    var vind:integer;
    begin
{ ancienne version }
    dataeditform.litspectre1D(pars[1]);
    result:=1;
    end;

    {lecture fichier 2D ancien format
    INPUT pars[1] nom du fichier
          pars[2] nom du spectre}
    function readspectre2D:integer;far;
    var vind:integer;
    begin
    interpreteurform.timer1.enabled:=false;
    vind:=deuxd.indexof(pars[2]);
    if vind<0 then vind:=deuxd.addspectre(pars[2],1,1,1);

    if editdata.fexis(pars[1]) then
      begin
      deuxd.spect[vind].readfromfile(pars[1]);
      boitnoir.receivetext('ouverture de : ' + pars[1]+' dans : '+pars[2]);
      end
    else
      boitnoir.receivetext('!! echec ouverture : ' + pars[1]+' n existe pas');

    interpreteurform.timer1.enabled:=true;
    result:=1;
    end;

    {procedure de sauvegarde gnrale ancien format}
    {A SUPPRIMER ??
    function savespectre:integer;far;
    begin
    dataeditform.sauve(round(par[1]),pars[2]);
    result:=1;
    end;           }

    {lecture HADAS }
    {!! Le chemin est IMPOSE}
    function lectureFichierHADAS:integer;far
    var s:string;
    begin
         s:=pars[1]+IntToStr(round(par[2]));
         graph2D.lectureFichierHADAS('d:\temp\'+s+'.img');
    end;

    { INPUT: pars[1], le nom du spectre  sauvegarder }
    {        pars[2], le nom du fichier (avec chemin) }
    {        pars[3]+..+pars[10], le commentaire en premire ligne }
    function saveToASCII1D:integer;far;
    var fich:text;
        i,ind:integer;
    begin
         interpreteurform.timer1.enabled:=false;
         ind:=und.indexof(pars[1]);
         if ind<>-1 then begin
            und.spect[ind].comment:=pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10];
            und.spect[ind].saveToASCII(pars[2]);
            end;
         interpreteurform.timer1.enabled:=true;
    end;

    { INPUT: pars[1], le nom du spectre a sauvegarder }
    {        pars[2], le nom du fichier (avec chemin) }
    {        pars[3]+..+pars[10], le commentaire en premire ligne }
    {OUTPUT : Fichier type 4 col : X,Y,Z(=0), data     }
    function saveToASCII2D:integer;far;
    var fich:text;
        i,j,ind:integer;
    begin
         interpreteurform.timer1.enabled:=false;
         ind:=deuxd.indexof(pars[1]);
         if ind<>-1 then begin
         assignfile(fich,pars[2]);
         rewrite(fich);
         writeln(fich,pars[3]+pars[4]+pars[5]+pars[6]+pars[7]+pars[8]+pars[9]+pars[10]); { ecriture d'un commentaire en premire ligne }
         writeln(fich,FloatToStr(deuxd.spect[ind].moniteur));
         {writeln(fich,FloatToStr(deuxd.spect[ind].X));  ecriture de la longeur du spectre 2D en deuxime ligne
         writeln(fich,FloatToStr(deuxd.spect[ind].Y)); { ecriture de la longeur du spectre 2D en troisime ligne
         writeln(fich,FloatToStr(deuxd.spect[ind].LT)); { ecriture de la longeur du spectre 2D en quatrime ligne }
         for i:=0 to deuxd.spect[ind].X-1 do
             for j:=0 to deuxd.spect[ind].Y-1 do
                 {writeln(fich,intToStr(i)+#9+intToStr(j)+#9+'0'+#9+FloatToStr(deuxd.spect[ind].data[i,j,0].z));}
                 writeln(fich,FloatToStr(deuxd.spect[ind].data[i,j,0].z));
         closefile(fich);
         end;
         interpreteurform.timer1.enabled:=true;
    end;

    {fonction d'ouverture de spectre au nouveau format}
    {INPUT : par[1] : dim du spectre (=1,2,3)
             pars[2] : nom du fichier
             pars[3] : nom du spectre recepteur}
    function openspectre:integer;far;
    var dim,ind:integer;
    begin
    interpreteurform.timer1.enabled:=false;
    dim:=round(par[1]);
    if editdata.fexis(pars[2]) then
    begin
    case dim of
    1: begin
       ind:=und.addspectre(pars[3],1,1,1);
       und.spect[ind].open(pars[2]);
       end;
    2: begin
       ind:=deuxd.addspectre(pars[3],1,1,1);
       deuxd.spect[ind].open(pars[2]);
       end;
    3: begin
       ind:=troisd.addspectre(pars[3],1,1,1);
       troisd.spect[ind].open(pars[2]);
       end;
    end;
    {boitnoir.receivetext('ouverture de : ' + pars[2]+' dans : '+pars[3]);}
    end
    else boitnoir.receivetext('!! echec ouverture : ' + pars[2]+' n existe pas');
    interpreteurform.timer1.enabled:=true;
    end;

    function openNeXuS:integer;far;
    var dim,ind:integer;
    begin
    interpreteurform.timer1.enabled:=false;
    dim:=round(par[1]);
    if editdata.fexis(pars[2]) then
    begin
    case dim of
    1: begin
       ind:=und.addspectre(pars[3],1,1,1);
       und.spect[ind].readFromNeXus(pars[2]); 
       end;
    2: begin
       ind:=deuxd.addspectre(pars[3],1,1,1);
       deuxd.spect[ind].readFromNeXus(pars[2]);
       end;
    3: begin
       ind:=troisd.addspectre(pars[3],1,1,1);
       troisd.spect[ind].readFromNeXus(pars[2]);
       end;
    end;
    {boitnoir.receivetext('ouverture de : ' + pars[2]+' dans : '+pars[3]);}
    end
    else boitnoir.receivetext('!! echec ouverture : ' + pars[2]+' n existe pas');
    interpreteurform.timer1.enabled:=true;
    end;


    {fonction de sauvegarde de spectre au nouveau format}
    {INPUT : par[1] : dim du spectre (=1,2,3)
             pars[2] : nom du spectra a sauvegarder
             pars[3] : nom du fichier "nom complet avec chemin"}
    function SaveSpectre:integer;far;
    var dim,ind:integer;
    begin
    interpreteurform.timer1.enabled:=false;
    dim:=round(par[1]);
    case dim of
    1: begin
       ind:=und.indexof(pars[2]);
       if ind>0 then und.spect[ind].save(pars[3]);
       end;
    2: begin
       ind:=deuxd.indexof(pars[2]);
       if ind>0 then deuxd.spect[ind].save(pars[3]);
       end;
    3: begin
       ind:=troisd.indexof(pars[2]);
       if ind>0 then troisd.spect[ind].save(pars[3]);
       end;
    end;
    interpreteurform.timer1.enabled:=true;
    end;
    {fonction d'ouverture de spectre au format PAXY}
    {INPUT : pars[1] : Chemin termin par \
             par[2]  : index du fichier
             pars[3] : nom du spectre                               }
    function openPAXY:integer;far;
    var filename,temp:string;
        ind:integer;
        titre,nom,date,heure,temps:string;

    begin
    interpreteurform.timer1.enabled:=false;
    temp:='000'+floattostr(par[2]);
    temp:=copy(temp,length(temp)-3,4);
    filename:=pars[1]+'XY'+temp+'.dat';
    if editdata.fexis(filename) then
      begin
       ind:=deuxd.addspectre(pars[3],128,128,1);
       deuxd.spect[ind].readfromPAXY(filename,titre,nom,date,heure,temps);
      end
    else boitnoir.receivetext('!! echec ouverture : ' + filename +' n existe pas');
    
    interpreteurform.timer1.enabled:=true;

    End;
{ ======================================================================= }
{ ICI se trouvent les fonctions du script pour le traitement des spectres }
{ procdures agissant sur les spectres 1D }
    function DelSpectre1D:integer;far
    begin
         und.delete(pars[1]);
    end;
    function AddSpectre1D:integer;far;
    begin
         und.addition(pars[1],pars[2],pars[3]);
    end;
    function SubSpectre1D:integer;far;
    begin
       und.soustraction(pars[1],pars[2],pars[3]);
    end;

    function MultSpectre1D:integer;far;
    begin
       und.multiplication(pars[1],pars[2],pars[3]);
    end;
    function DivSpectre1D:integer;far;
    begin
       und.division(pars[1],pars[2],pars[3]);
    end;
    function ScalAddSpectre1D:integer;far;
    begin
        und.ScalAdd(par[1],pars[2],pars[3]);
    end;
    function ScalSubSpectre1D:integer;far;
    begin
        und.ScalSub(par[1],pars[2],pars[3]);
    end;
    function ScalMultSpectre1D:integer;far;
    begin
        und.ScalMult(par[1],pars[2],pars[3]);
    end;
    function ScalDivSpectre1D:integer;far;
    begin
        und.ScalDiv(par[1],pars[2],pars[3]);
    end;
    function Sqrt1D:integer;far;
    begin
        und.SquareRoot(pars[1],pars[2]);
    end;

    {integrale entre Xmin et Xmax
    pars[1] Nom1D
    par[2], par[3] xmin et xax  en Pixel si type raw ou absolue si une typeX<>raw
    par[4] nom variable parseur
    le rsultat est stok dans la boite noire
    ou dans la variable du parseur pars[4]si <>'' ex "var"}
    function IntegraleSpectre1D:integer;far
    var vind:integer;
        temp:real;
    begin
    vind:=und.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=und.spect[vind].IntegraleSpectre1D(par[2],par[3]);
       if pars[4]<>'' then interpreteurform.parser1.setvariable(pars[6],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;
    end;

{ procdures agissant sur les spectres 2D }
    function DelSpectre2D:integer;far
    begin
         deuxd.delete(pars[1]);
    end;
    function AddSpectre2D:integer;far;
    begin
         deuxd.addition(pars[1],pars[2],pars[3]);
    end;
    function SubSpectre2D:integer;far;
    begin
         deuxd.soustraction(pars[1],pars[2],pars[3]);
    end;
    function MultSpectre2D:integer;far;
    begin
       deuxd.multiplication(pars[1],pars[2],pars[3]);
    end;
    function DivSpectre2D:integer;far;
    begin
       deuxd.division(pars[1],pars[2],pars[3]);
    end;
    function ScalAddSpectre2D:integer;far;
    begin
        deuxd.ScalAdd(par[1],pars[2],pars[3]);
    end;
    function ScalSubSpectre2D:integer;far;
    begin
        deuxd.ScalSub(par[1],pars[2],pars[3]);
    end;
    function ScalMultSpectre2D:integer;far;
    begin
        deuxd.ScalMult(par[1],pars[2],pars[3]);
    end;
    function ScalDivSpectre2D:integer;far;
    begin
        deuxd.ScalDiv(par[1],pars[2],pars[3]);
    end;
    function Sqrt2D:integer;far;
    begin
        deuxd.SquareRoot(pars[1],pars[2]);
    end;

    { lissage d'une courbe par moyenne glissante }
    { INPUT : pars[1] la courbe 1D a lisser     }
    {         pars [2] le nombre de points sur lesquels il faut moyenner }
    {         pars[3] la courbe de sorite       }
    { OUTPUT : pars[3] contient la courbe lisse }
    function Smooth1D:integer;far
    var i,j:integer;
        idx1,idx2,tailleX1:integer;
    begin
        idx1:=und.indexof(pars[1]);tailleX1:=und.spect[idx1].X;
        idx2:=und.addSpectre(pars[3],TailleX1,1,1);
        und.spect[idx2].typeX:=und.spect[idx1].typeX;
        for i:=0 to tailleX1-1 do
        begin
           und.spect[idx2].data[i,0,0].X:=und.spect[idx1].data[i,0,0].X;
           und.spect[idx2].data[i,0,0].Z:=und.spect[idx1].data[i,0,0].Z;
        end;
        for i:=round((par[2]-1)/2) to TailleX1-1-round((par[2]-1)/2) do
        begin
           und.spect[idx2].data[i,0,0].Z:=0;
           for j:=-round((par[2]-1)/2) to round((par[2]-1)/2) do
           begin
              und.spect[idx2].data[i,0,0].Z:=und.spect[idx2].data[i,0,0].Z+und.spect[idx1].data[i+j,0,0].Z;
           end;
           und.spect[idx2].data[i,0,0].Z:=und.spect[idx2].data[i,0,0].Z/par[2];
        end;
    end;

    { lissage d'une courbe par moyenne glissante }
    { INPUT : pars[1] la courbe 1D a lisser     }
    {         pars [2] le nombre de points sur lesquels il faut moyenner }
    {         pars[3] la courbe de sorite       }
    { OUTPUT : pars[3] contient la courbe lisse }
    function Smooth2D:integer;far
    var i,j,k,l:integer;
        idx1,idx2,tailleX1,tailleY1:integer;
    begin
        idx1:=deuxd.indexof(pars[1]);tailleX1:=deuxd.spect[idx1].X;tailleY1:=deuxd.spect[idx1].Y;
        idx2:=deuxd.addSpectre(pars[3],TailleX1,TailleY1,1);
        deuxd.spect[idx2].typeX:=deuxd.spect[idx1].typeX;
        deuxd.spect[idx2].typeY:=deuxd.spect[idx1].typeY;
        for i:=0 to tailleX1-1 do
          for j:=0 to tailleY1-1 do
          begin
            deuxd.spect[idx2].data[i,j,0].X:=deuxd.spect[idx1].data[i,j,0].X;
            deuxd.spect[idx2].data[i,j,0].Y:=deuxd.spect[idx1].data[i,j,0].Y;
            deuxd.spect[idx2].data[i,j,0].Z:=deuxd.spect[idx1].data[i,j,0].Z;
          end;
        for i:=round((par[2]-1)/2) to TailleX1-1-round((par[2]-1)/2) do
        for j:=round((par[2]-1)/2) to TailleY1-1-round((par[2]-1)/2) do
        begin
           deuxd.spect[idx2].data[i,j,0].Z:=0;
           for k:=-round((par[2]-1)/2) to round((par[2]-1)/2) do
           for l:=-round((par[2]-1)/2) to round((par[2]-1)/2) do
           begin
              deuxd.spect[idx2].data[i,j,0].Z:=deuxd.spect[idx2].data[i,j,0].Z+deuxd.spect[idx1].data[i+k,j+l,0].Z;
           end;
           deuxd.spect[idx2].data[i,j,0].Z:=deuxd.spect[idx2].data[i,j,0].Z/(par[2]*par[2]);
        end;
    end;

    {integrale entre Xmin, ymin, Xmax, ymax
    pars[1] Nom2D
    par[2], par[3],par[4], par[5], xmin, ymin,xmax, ymax
    par[6] nom variable parseur
    le rsultat est stok dans la boite noire
    ou dans la variable du parseur pars[6]si <>'' ex "var"}
    function IntegraleSpectre2D:integer;far
    var vind:integer;
        temp:real;
    begin
    vind:=deuxd.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=deuxd.spect[vind].IntegraleSpectre2D(par[2],par[3],par[4],par[5]);
       if pars[6]<>'' then interpreteurform.parser1.setvariable(pars[6],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;

    end;
    {Normalise le spectre  un moniteur de reference}
    {par[1]:moniteur de ref, Pars[2]: spectre ini; pars[3]:spectre normalis}
    function NormMoniSpectre2D:integer;far;
    begin
    interpreteurform.timer1.enabled:=false;
    if deuxd.indexof(pars[2])<>-1 then
       begin
       if deuxd.spect[deuxd.indexof(pars[2])].moniteur<>0 then
         begin
         deuxd.ScalMult(par[1]/deuxd.spect[deuxd.indexof(pars[2])].moniteur,pars[2],pars[3]);
         deuxd.spect[deuxd.indexof(pars[3])].moniteur:=par[1];
         {boitnoir.receivetext('normalisation :' + pars[2]+' moniteur ='+pars[1]);}
         end
       else
         boitnoir.receivetext('!! echec normalisation :' + pars[2]+' moniteur nul');
       end
    else
       boitnoir.receivetext('!! echec normalisation :' + pars[2]+' non trouv');
    interpreteurform.timer1.enabled:=true;
    end;

{ fonctions de projection }
{ INPUT : pars[1], nom du spectre 2D}
{         par[2], ymin; par[3] ymax      }
{         pars[4], le nom du spectre 1D de sortie }
{ OUTPUT: le resultat est stock dans le spectre unD 'pars[4]' }
{ A NOTER : pour l'utilisateur : projection verticale = projection SUR la direction verticale }
{           pour le programmeur (dans l'unit EditData), projection verticale = projection suivant la verticale }
    function ProjectionHSpectre2D:integer;far
    var vind:integer;
    begin
        vind:=deuxd.indexof(pars[1]);
        if vind>0 then unD.add(deuxd.spect[vind].ProjectionVSpectre2D(pars[4],par[2],par[3]));
    end;
    function ProjectionVSpectre2D:integer;far
    var vind:integer;
    begin
        vind:=deuxd.indexof(pars[1]);
        if vind>0 then unD.add(deuxd.spect[vind].ProjectionHSpectre2D(pars[4],par[2],par[3]));
    end;

    { INPUT : Pars[1]:nom du spectre 2D; pars[2]:nom du spectre 1D
    {         par[3],par[4]: X0, Y0 centre; par[5]: nombre de points (resolution)
    { OUTPUT: Spectre 1D pars[2]}
    function SommeCirculaireSpectre2D:integer;far
    var vind:integer;
    begin
        vind:=deuxd.indexof(pars[1]);
        if vind>0
        then unD.add(deuxd.spect[vind].SommeCirculaireSpectre2D(pars[2],par[3],par[4],par[5]));
    end;

    {fonction appellant une somme petits angles
    INPUT : Pars[1]:nom du spectre 2D; pars[2]:nom du spectre 1D
            pars[3]:nom du masque (si ce masque n'existe pas, le prg n'utilise pas de masquage
            par[4],par[5]: X0, Y0 centre; par[6]: nombre de points (resolution)
            par[7]: lambda (PAPOL :8); par[8] : delta Pixel en m (PAPOl : 0.005); par[9]: dist Ech/detect en m
    OUTPUT: Spectre 1D pars[2]}
    function SommeDNPA:integer;far
    begin
    interpreteurform.timer1.enabled:=false;
    if deuxd.indexof(pars[1])<>-1 then
       begin
       und.add(deuxd.spect[deuxd.indexof(pars[1])].SommePetitsAngles(pars[2],pars[3],par[4],par[5],par[6],par[7],par[8],par[9]));
       boitnoir.receivetext('Somme DNPA :' + pars[1]+' dans '+pars[2]);
       if deuxd.indexof(pars[3])<0 then boitnoir.receivetext('!!ATTENTION : masque ' + pars[3]+' non trouv ');
       end
    else boitnoir.receivetext('!! echec Somme DNPA : ' + pars[1]+' non trouv');
    interpreteurform.timer1.enabled:=true;
    end;

    {fonction multipliant le spectre deuxd.indexof(Pars[1]) par un secteur de 1 et 0 ailleurs}
    {Pars[1]:nom du spectre 2D;par[2],par[3]: X0, Y0 centre du secteur}
    {par[4]: angle median du secteur en convention geographique: 0 a midi, 90 a 3H, 180 a 6H, 270 a 9H  }
    {par[5]: angle total d'ouverture du secteur (plus ou moins thetaouv/2)}
    function MasqueSecteur:integer;far
    begin
    if deuxd.indexof(pars[1])<>-1 then
    deuxd.spect[deuxd.indexof(Pars[1])].MasqueSecteur(Par[2],Par[3],Par[4],Par[5]);
    end;
    {Calcul le barycentre d'un spectre 2D afin de determiner le bean centre}
    {pars[1] : Nom du spectre 2D}
    function Barycentre2D:integer;far
    var vind,i,j:integer;
        X,Y,somme:real;
    begin
    vind:=deuxd.indexof(pars[1]);
    X:=0;Y:=0;somme:=0;
    if vind>0 then
      begin
      for i:=0 to deuxd.spect[vind].X-1 do
          for j:=0 to deuxd.spect[vind].Y-1 do
            begin
            X:=X+deuxd.spect[vind].data[i,j,0].z*i;
            Y:=Y+deuxd.spect[vind].data[i,j,0].z*j;
            somme:=somme+deuxd.spect[vind].data[i,j,0].z;
            end;
      if somme<>0 then
         begin
         X:=X/somme;Y:=Y/somme;
         end;
      boitnoir.receivetext('barycentre '+deuxd.spect[vind].nom+' : X0='+floattostr(X)+' Y0='+floattostr(Y));
      end;
    end;
    { fonction de concatenation de spectres 1D en un spectre 2D }
    { INPUT : pars[1], rpertoire de lecture   }
    {         pars[2], nom de base des fichiers 1D }
    {         par[3], indice min, par[5], indice max }
    {         par[4], le step     }
    {         pars[6], extension des fichiers    }
    {         pars[7], nomdu spectre 2d de sortie, nom interne au programme }
    function concat1D:integer;far;
    var fich:text;
        i,imin,imax,j,ind,ind2D,longueurY:integer;
        s,s1:string;
    begin
       { lecture des fichiers 1D }
       imin:=round(par[3]);imax:=round(par[5]);
       interpreteurform.timer1.enabled:=false;
       { determination de la taille en Y }
       s:=pars[1]+pars[2]+intToStr(imin)+pars[6]; { nom complet du fichier }
       s1:=pars[2]+intToStr(round(imin))+pars[6]; { nom a donner au spectre }
       if editdata.fexis(s) then
       begin ind:=und.addspectre(s1,1,1,1); und.spect[ind].open(s) end
       else boitnoir.receivetext('!! echec ouverture : ' + s + ' n''existe pas');
       longueurY:=und.spect[ind].X;
       ind2D:=deuxd.addSpectre(pars[7],round((imax-imin)/par[4])+1,longueurY,1);
       deuxd.spect[ind2D].typeX:='raw';deuxd.spect[ind2D].typeY:='raw';

         i:=imin;
         while i<=imax do
         begin
             s:=pars[1]+pars[2]+intToStr(i)+pars[6]; { nom complet du fichier }
             s1:=pars[2]+intToStr(round(i))+pars[6]; { nom a donner au spectre }
             if editdata.fexis(s) then
             begin ind:=und.addspectre(s1,1,1,1); und.spect[ind].open(s);  end
             else boitnoir.receivetext('!! echec ouverture : ' + s + ' n''existe pas');
             { transfert dans le spectre 2D }
             for j:=0 to longueurY-1 do
             begin deuxd.spect[ind2D].data[round((i-imin)/par[4]),j,0].X:=i-imin;
                   deuxd.spect[ind2D].data[round((i-imin)/par[4]),j,0].Y:=j;
                   deuxd.spect[ind2D].data[round((i-imin)/par[4]),j,0].Z:=und.spect[ind].data[j,0,0].z;
                   end;
             und.delete(s1);
             i:=i+round(par[4]);
         end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de concatenation de deux spectres spectres 2D en un spectre 2D }
    { INPUT : pars[1], nom du premier spectre   }
    {         pars[2], nom du deuxime spectre }
    {         par[3], nom du spectre de sortie }
    { NOTA : il faut que les steps et les units des deux spectres soient les memes  }
    function concat2D:integer;far;
    var fich:text;
        i,imin,imax,j,ind,ind2D,longueurY:integer;
        idx1,idx2,idx3:integer;
        xmin1,xmax1,ymin1,ymax1,xstep1,ystep1:double;
        xmin2,xmax2,ymin2,ymax2,xstep2,ystep2:double;
        xmin3,xmax3,ymin3,ymax3,xstep3,ystep3:double;
        tailleX1,TailleX2,TailleX3,tailleY1,tailleY2,tailleY3:integer;
        xaux,yaux,zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=deuxd.indexof(pars[1]);idx2:=deuxd.indexof(pars[2]);
       tailleX1:=deuxd.spect[idx1].X;tailleX2:=deuxd.spect[idx2].X;
       tailleY1:=deuxd.spect[idx1].Y;tailleY2:=deuxd.spect[idx2].Y;
       Xmin1:=deuxd.spect[idx1].data[0,0,0].X;Ymin1:=deuxd.spect[idx1].data[0,0,0].Y;
       Xmax1:=deuxd.spect[idx1].data[tailleX1-1,tailleY1-1,0].X;Ymax1:=deuxd.spect[idx1].data[tailleX1-1,tailleY1-1,0].Y;
       if tailleX1<>1 then Xstep1:=(Xmax1-Xmin1)/(tailleX1-1) else Xstep1:=1;
       if tailleY1<>1 then Ystep1:=(Ymax1-Ymin1)/(tailleY1-1) else Ystep1:=1;
       Xmin2:=deuxd.spect[idx2].data[0,0,0].X;Ymin2:=deuxd.spect[idx2].data[0,0,0].Y;
       Xmax2:=deuxd.spect[idx2].data[tailleX2-1,tailleY2-1,0].X;Ymax2:=deuxd.spect[idx2].data[tailleX2-1,tailleY2-1,0].Y;
       if tailleX2<>1 then Xstep2:=(Xmax2-Xmin2)/(tailleX2-1) else Xstep2:=1;
       if tailleY2<>1 then Ystep2:=(Ymax2-Ymin2)/(tailleY2-1) else Ystep2:=1;
       { verification de la compatibilit des spectres }
       if (deuxd.spect[idx1].typeX<>deuxd.spect[idx2].typeX)
       then MessageDlg('X coordinate types not compatible',mtError,[mbOk],0);
       if (deuxd.spect[idx1].typeY<>deuxd.spect[idx2].typeY)
       then MessageDlg('Y coordinate types not compatible',mtError,[mbOk],0);
       if abs(Xstep1-Xstep2)>1e-8 then MessageDlg('X step sizes not compatible',mtError,[mbOk],0);
       if abs(Ystep1-Ystep2)>1e-8 then MessageDlg('Y step sizes not compatible',mtError,[mbOk],0);
       { determination de la taille du nouveau spectre et initialisation }
       Xmin3:=min(Xmin1,Xmin2);Ymin3:=min(Ymin1,Ymin2);
       Xmax3:=max(Xmax1,Xmax2);Ymax3:=max(Ymax1,Ymax2);
       Xstep3:=Xstep1;Ystep3:=Ystep1;
       TailleX3:=round((Xmax3-Xmin3)/XStep3+1);TailleY3:=round((Ymax3-Ymin3)/YStep3+1);
       idx3:=deuxd.addSpectre(pars[3],TailleX3,TailleY3,1);
       deuxd.spect[idx3].typeX:=deuxd.spect[idx1].typeX;deuxd.spect[idx3].typeY:=deuxd.spect[idx1].typeY;
       { remplissage du nouveau spectre }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
        for j:=0 to TailleY1-1 do
          begin
            xaux:=deuxd.spect[idx1].data[i,j,0].x;
            yaux:=deuxd.spect[idx1].data[i,j,0].y;
            zaux:=deuxd.spect[idx1].data[i,j,0].z;
            deuxd.spect[idx3].data[round((xaux-xmin3)/xstep1),round((yaux-ymin3)/ystep1),0].X:=xaux;
            deuxd.spect[idx3].data[round((xaux-xmin3)/xstep1),round((yaux-ymin3)/ystep1),0].Y:=yaux;
            deuxd.spect[idx3].data[round((xaux-xmin3)/xstep1),round((yaux-ymin3)/ystep1),0].Z:=zaux;
          end;
       { scan du deuxime spectre }
       for i:=0 to TailleX2-1 do
        for j:=0 to TailleY2-1 do
          begin
            xaux:=deuxd.spect[idx2].data[i,j,0].x;
            yaux:=deuxd.spect[idx2].data[i,j,0].y;
            zaux:=deuxd.spect[idx2].data[i,j,0].z;
            deuxd.spect[idx3].data[round((xaux-xmin3)/xstep1),round((yaux-ymin3)/ystep1),0].X:=xaux;
            deuxd.spect[idx3].data[round((xaux-xmin3)/xstep1),round((yaux-ymin3)/ystep1),0].Y:=yaux;
            deuxd.spect[idx3].data[round((xaux-xmin3)/xstep1),round((yaux-ymin3)/ystep1),0].Z:=zaux;
          end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de transfert d'un spectre 1D vers 2D ; vital pour les fonctions Append }
    { INPUT : pars[1], nom du spectre 2D  }
    {         pars[2], nom du spectre 1D}
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function Convert1Dto2Drow:integer;far;
    var fich:text;
        i:integer;
        idx1,idx2:integer;
        tailleX1:integer;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=und.indexof(pars[1]);
       tailleX1:=und.spect[idx1].X;
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx2:=deuxd.addSpectre(pars[2],TailleX1,1,1);
       deuxd.spect[idx2].typeX:=und.spect[idx2].typeX;
       deuxd.spect[idx2].typeY:='raw';
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
         begin  deuxd.spect[idx2].data[i,0,0].X:=und.spect[idx1].data[i,0,0].X;
                deuxd.spect[idx2].data[i,0,0].Y:=0;
                deuxd.spect[idx2].data[i,0,0].Z:=und.spect[idx1].data[i,0,0].Z end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de transfert d'un spectre 1D vers 2D avec entree de y; vital pour les fonctions Append }
    { INPUT : pars[1], nom du spectre 1D}
    {         pars[2], nom du spectre 2D}
    {         pars[3], y0               }
    {         pars[4], type des oronnes        }
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function Convert1Dto2DrowY:integer;far;
    var fich:text;
        i:integer;
        idx1,idx2:integer;
        tailleX1:integer;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=und.indexof(pars[1]);
       tailleX1:=und.spect[idx1].X;
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx2:=deuxd.addSpectre(pars[2],TailleX1,1,1);
       deuxd.spect[idx2].typeX:=und.spect[idx2].typeX;
       deuxd.spect[idx2].typeY:=pars[4];
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
         begin  deuxd.spect[idx2].data[i,0,0].X:=und.spect[idx1].data[i,0,0].X;
                deuxd.spect[idx2].data[i,0,0].Y:=par[3];
                deuxd.spect[idx2].data[i,0,0].Z:=und.spect[idx1].data[i,0,0].Z end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de transfert d'un spectre 1D vers 2D ; vital pour les fonctions Append }
    { INPUT : pars[1], nom du spectre 2D  }
    {         pars[2], nom du spectre 1D}
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function Convert1Dto2Dcol:integer;far;
    var fich:text;
        i:integer;
        idx1,idx2:integer;
        tailleX1:integer;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=und.indexof(pars[1]);
       tailleX1:=und.spect[idx1].X;
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx2:=deuxd.addSpectre(pars[2],1,TailleX1,1);
       deuxd.spect[idx2].typeX:='raw';
       deuxd.spect[idx2].typeY:=und.spect[idx2].typeX;
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
         begin  deuxd.spect[idx2].data[0,i,0].X:=0;
                deuxd.spect[idx2].data[0,i,0].Y:=und.spect[idx1].data[i,0,0].X;;
                deuxd.spect[idx2].data[0,i,0].Z:=und.spect[idx1].data[i,0,0].Z end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de transfert d'un spectre 1D vers 2D ; vital pour les fonctions Append }
    { INPUT : pars[1], nom du spectre 2D  }
    {         pars[2], nom du spectre 1D}
    {         par[3], valeur de l'abscisse                     }
    {         pars[4], type des abscisses        }
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function Convert1Dto2DcolX:integer;far;
    var fich:text;
        i:integer;
        idx1,idx2:integer;
        tailleX1:integer;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=und.indexof(pars[1]);
       tailleX1:=und.spect[idx1].X;
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx2:=deuxd.addSpectre(pars[2],1,TailleX1,1);
       deuxd.spect[idx2].typeX:=pars[4];
       deuxd.spect[idx2].typeY:=und.spect[idx2].typeX;
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
         begin  deuxd.spect[idx2].data[i,0,0].X:=par[3];
                deuxd.spect[idx2].data[0,i,0].Y:=und.spect[idx1].data[i,0,0].X;;
                deuxd.spect[idx2].data[0,i,0].Z:=und.spect[idx1].data[i,0,0].Z end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction d'append d'un spectre 1D  un spectre 2D }
    { INPUT : pars[1], nom du spectre 2D  }
    {         pars[2], nom du spectre 1D}
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function appendCol:integer;far;
    var i,j:integer;
        idx1,idx2,idx3:integer;
        tailleX1,TailleX2,tailleY1,tailleY2:integer;
        zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=deuxd.indexof(pars[1]);idx2:=und.indexof(pars[2]);
       tailleX1:=deuxd.spect[idx1].X;tailleY1:=deuxd.spect[idx1].Y;tailleX2:=und.spect[idx2].X;
       { verification de la compatibilit des spectres }
       if (tailleY1<>tailleX2) then MessageDlg('Spectra sizes are not compatible!',mtError,[mbOk],0);
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx3:=deuxd.addSpectre(pars[1]+'.TMP',TailleX1+1,TailleY1,1);
       deuxd.spect[idx3].typeX:='raw';deuxd.spect[idx3].typeY:='raw';
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
         for j:=0 to TailleY1-1 do
         begin  deuxd.spect[idx3].data[i,j,0].X:=deuxd.spect[idx1].data[i,j,0].X;
                deuxd.spect[idx3].data[i,j,0].Y:=deuxd.spect[idx1].data[i,j,0].Y;
                deuxd.spect[idx3].data[i,j,0].Z:=deuxd.spect[idx1].data[i,j,0].Z;
         end;
       for j:=0 to TailleY1-1 do
          begin
            zaux:=und.spect[idx2].data[j,0,0].z;
            deuxd.spect[idx3].data[tailleX1,j,0].X:=tailleX1;
            deuxd.spect[idx3].data[tailleX1,j,0].Y:=und.spect[idx2].data[j,0,0].Y;
            deuxd.spect[idx3].data[tailleX1,j,0].Z:=zaux;
          end;
       deuxd.deletespectre(idx1);
       deuxd.spect[idx3].Nom:=pars[1];
       interpreteurform.timer1.enabled:=true;
    end;

        { fonction d'append d'un spectre 1D  un spectre 2D }
    { INPUT : pars[1], nom du spectre 2D  }
    {         pars[2], nom du spectre 1D}
    {         par[3], la valeur de l'abscisse          }
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function appendColX:integer;far;
    var i,j:integer;
        idx1,idx2,idx3:integer;
        tailleX1,TailleX2,tailleY1,tailleY2:integer;
        zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=deuxd.indexof(pars[1]);idx2:=und.indexof(pars[2]);
       tailleX1:=deuxd.spect[idx1].X;tailleY1:=deuxd.spect[idx1].Y;tailleX2:=und.spect[idx2].X;
       { verification de la compatibilit des spectres }
       if (tailleY1<>tailleX2) then MessageDlg('Spectra sizes are not compatible!',mtError,[mbOk],0);
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx3:=deuxd.addSpectre(pars[1]+'.TMP',TailleX1+1,TailleY1,1);
       deuxd.spect[idx3].typeX:='raw';deuxd.spect[idx3].typeY:='raw';
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
         for j:=0 to TailleY1-1 do
         begin  deuxd.spect[idx3].data[i,j,0].X:=deuxd.spect[idx1].data[i,j,0].X;
                deuxd.spect[idx3].data[i,j,0].Y:=deuxd.spect[idx1].data[i,j,0].Y;
                deuxd.spect[idx3].data[i,j,0].Z:=deuxd.spect[idx1].data[i,j,0].Z;
         end;
       for j:=0 to TailleY1-1 do
          begin
            zaux:=und.spect[idx2].data[j,0,0].z;
            deuxd.spect[idx3].data[tailleX1,j,0].X:=par[3];
            deuxd.spect[idx3].data[tailleX1,j,0].Y:=und.spect[idx2].data[j,0,0].Y;
            deuxd.spect[idx3].data[tailleX1,j,0].Z:=zaux;
          end;
       deuxd.deletespectre(idx1);
       deuxd.spect[idx3].Nom:=pars[1];
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction d'append d'un spectre 1D  un spectre 2D }
    { INPUT : pars[1], nom du spectre 2D  }
    {         pars[2], nom du spectre 1D}
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function appendRow:integer;far;
    var fich:text;
        i,imin,imax,j,ind,ind2D,longueurY:integer;
        idx1,idx2,idx3:integer;
        tailleX1,TailleX2,TailleX3,tailleY1,tailleY2,tailleY3:integer;
        xaux,yaux,zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=deuxd.indexof(pars[1]);idx2:=und.indexof(pars[2]);
       tailleX1:=deuxd.spect[idx1].X;tailleY1:=deuxd.spect[idx1].Y;tailleX2:=und.spect[idx2].X;
       { verification de la compatibilit des spectres }
       if (tailleX1<>tailleX2) then MessageDlg('Spectra sizes are not compatible!',mtError,[mbOk],0);
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx3:=deuxd.addSpectre(pars[1]+'.TMP',TailleX1,TailleY1+1,1);
       deuxd.spect[idx3].typeX:='raw';deuxd.spect[idx3].typeY:='raw';
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       { recopie du spectre prcdent }
       for i:=0 to TailleX1-1 do
         for j:=0 to TailleY1-1 do
         begin  deuxd.spect[idx3].data[i,j,0].X:=deuxd.spect[idx1].data[i,j,0].X;
                deuxd.spect[idx3].data[i,j,0].Y:=deuxd.spect[idx1].data[i,j,0].Y;
                deuxd.spect[idx3].data[i,j,0].Z:=deuxd.spect[idx1].data[i,j,0].Z;
         end;
       for j:=0 to TailleX1-1 do
          begin
            zaux:=und.spect[idx2].data[j,0,0].z;
            {deuxd.spect[idx3].data[j,tailleY1,0].X:=j;}
            deuxd.spect[idx3].data[j,tailleY1,0].X:=und.spect[idx2].data[j,0,0].X;
            deuxd.spect[idx3].data[j,tailleY1,0].Y:=tailleY1;
            deuxd.spect[idx3].data[j,tailleY1,0].Z:=zaux;
          end;

       deuxd.deletespectre(idx1);
       deuxd.spect[idx3].Nom:=pars[1];
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction d'append d'un spectre 1D  un spectre 2D avec determination de Y}
    { INPUT : pars[1], nom du spectre 2D}
    {         pars[2], nom du spectre 1D}
    {         pars[3], y0               }
    { NOTA : il faut que la taille du spectre 1D soit compatoble  2D.tailleY }
    {        pour le moment, ca suppose que le type est 'raw'                 }
    function appendRowY:integer;far;
    var fich:text;
        i,imin,imax,j,ind,ind2D,longueurY:integer;
        idx1,idx2,idx3:integer;
        tailleX1,TailleX2,TailleX3,tailleY1,tailleY2,tailleY3:integer;
        xaux,yaux,zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=deuxd.indexof(pars[1]);idx2:=und.indexof(pars[2]);
       tailleX1:=deuxd.spect[idx1].X;tailleY1:=deuxd.spect[idx1].Y;tailleX2:=und.spect[idx2].X;
       { verification de la compatibilit des spectres }
       if (tailleX1<>tailleX2) then MessageDlg('Spectra sizes are not compatible!',mtError,[mbOk],0);
       { determination de la taille du nouveau spectre et initialisation }
       { **********  OPERATION STRICTEMENT ILLEGALE ************* }
       { redomensionnement du spectres ; on a beauc<oup de chances de perdre des data }
       idx3:=deuxd.addSpectre(pars[1]+'.TMP',TailleX1,TailleY1+1,1);
       {deuxd.spect[idx3].typeX:='raw'};deuxd.spect[idx3].typeY:='raw';
       deuxd.spect[idx3].typeX:=und.spect[idx1].typeX;
       { remplissage de la colonne supplmentaire }
       { scan du premier spectre }
       { recopie du spectre prcdent }
       for i:=0 to TailleX1-1 do
         for j:=0 to TailleY1-1 do
         begin  deuxd.spect[idx3].data[i,j,0].X:=deuxd.spect[idx1].data[i,j,0].X;
                deuxd.spect[idx3].data[i,j,0].Y:=deuxd.spect[idx1].data[i,j,0].Y;
                deuxd.spect[idx3].data[i,j,0].Z:=deuxd.spect[idx1].data[i,j,0].Z;
         end;
       for j:=0 to TailleX1-1 do
          begin
            zaux:=und.spect[idx2].data[j,0,0].z;
            {deuxd.spect[idx3].data[j,tailleY1,0].X:=j;}
            deuxd.spect[idx3].data[j,tailleY1,0].X:=und.spect[idx2].data[j,0,0].X;
            deuxd.spect[idx3].data[j,tailleY1,0].Y:=par[3];
            deuxd.spect[idx3].data[j,tailleY1,0].Z:=zaux;
          end;
       deuxd.deletespectre(idx1);
       deuxd.spect[idx3].Nom:=pars[1];
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de redimmension d'un spectre 1D}
    { INPUT : pars[1], nom du spectre 1D #1     }
    {         pars[2], xmin                     }
    {         pars[3], xmax                     }
    {         pars[4], nom du spectre 1D #2     }
    function resize1D:integer;far;
    var fich:text;
        i,j:integer;
        idx1,idx2:integer;
        tailleX1,TailleX2:integer;
        xmin,xmax,xstep,x0,xN:double;

    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=und.indexof(pars[1]);
       tailleX1:=und.spect[idx1].X;

       { determination de la taille du nouveau spectre et initialisation }
       Xmin:=par[2];
       Xmax:=par[3];

       {x0 premier point du fichier 1D, xN dernier point}
       X0:=und.spect[idx1].data[0,0,0].X;
       XN:=und.spect[idx1].data[tailleX1-1,0,0].X;
       Xstep:=(XN-X0)/(tailleX1-1);

       {creation du nouveau spectre 1D}
       TailleX2:=round((Xmax-Xmin)/Xstep)+1;
       idx2:=und.addSpectre(pars[4],TailleX2,1,1);
       und.spect[idx2].typeX:=und.spect[idx1].typeX;
       und.spect[idx1].typeY:='raw';
       j:=0;
       for i:=0 to TailleX2-1 do
         begin
         und.spect[idx2].data[i,0,0].X:=Xmin+i*Xstep;
         und.spect[idx2].data[i,0,0].Y:=0;
         if und.spect[idx2].data[i,0,0].X<X0 then
                begin
                und.spect[idx2].data[i,0,0].Z:=0;
                inc(j);
                end;
         if (und.spect[idx2].data[i,0,0].X>=X0) and (und.spect[idx2].data[i,0,0].X<=XN) then und.spect[idx2].data[i,0,0].Z:=und.spect[idx1].data[i-j,0,0].Z;
         if und.spect[idx2].data[i,0,0].X>=XN then und.spect[idx2].data[i,0,0].Z:=0;
         end;

       und.spect[idx2].Nom:=pars[4];
       interpreteurform.timer1.enabled:=true;
    end;


    { fonction de redimensionnement d'un spectre 2D     }
    { INPUT : pars[1], nom du premier spectre           }
    {         pars[2], xmin; pars[3], xmax;  }
    {         par[4], nom du spectre de sortie }
    function extract1D:integer;far;
    var i,j:integer;
        tailleX1,tailleX2,idx1,idx2:integer;
        xmin1,xmax1,xstep1,xaux,zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=und.indexof(pars[1]);
       tailleX1:=und.spect[idx1].X;
       Xmin1:=und.spect[idx1].data[0,0,0].X;
       Xmax1:=und.spect[idx1].data[tailleX1-1,0,0].X;
       Xstep1:=(Xmax1-Xmin1)/(tailleX1-1);
       { creation du nouveau spectre }
       tailleX2:=round((par[3]-par[2])/XStep1+1);
       { determination de la taille du nouveau spectre et initialisation }
       idx2:=und.addSpectre(pars[4],TailleX2,1,1);
       und.spect[idx2].typeX:=und.spect[idx1].typeX;
       { remplissage du nouveau spectre }  { scan du premier spectre }
       for i:=0 to TailleX1-1 do
          begin
            xaux:=und.spect[idx1].data[i,0,0].x;
            zaux:=und.spect[idx1].data[i,0,0].z;
            if (xaux>=par[2]) and (xaux<=par[3]) then
            begin
            und.spect[idx2].data[round((xaux-par[2])/xstep1),0,0].X:=xaux;
            und.spect[idx2].data[round((xaux-par[2])/xstep1),0,0].Z:=zaux;
            end;
          end;
       interpreteurform.timer1.enabled:=true;
    end;

    { fonction de redimensionnement d'un spectre 2D     }
    { INPUT : pars[1], nom du premier spectre           }
    {         pars[2], xmin; pars[3], ymin; pars[4],xmax; pars[5], ymax }
    {         par[6], nom du spectre de sortie }
    function extract2D:integer;far;
    var i,j:integer;
        tailleX1,tailleY1,tailleX2,tailleY2,idx1,idx2:integer;
        xmin1,xmax1,ymin1,ymax1,xstep1,ystep1,xaux,yaux,zaux:double;
    begin
       interpreteurform.timer1.enabled:=false;
       { soit a determiner la taille du spectre de sortie }
       idx1:=deuxd.indexof(pars[1]);
       tailleX1:=deuxd.spect[idx1].X;tailleY1:=deuxd.spect[idx1].Y;
       Xmin1:=deuxd.spect[idx1].data[0,0,0].X;Ymin1:=deuxd.spect[idx1].data[0,0,0].Y;
       Xmax1:=deuxd.spect[idx1].data[tailleX1-1,tailleY1-1,0].X;Ymax1:=deuxd.spect[idx1].data[tailleX1-1,tailleY1-1,0].Y;
       Xstep1:=(Xmax1-Xmin1)/(tailleX1-1);Ystep1:=(Ymax1-Ymin1)/(tailleY1-1);
       { creation du nouveau spectre }
       tailleX2:=round((par[4]-par[2])/XStep1+1);
       tailleY2:=round((par[5]-par[3])/YStep1+1);
       { determination de la taille du nouveau spectre et initialisation }
       idx2:=deuxd.addSpectre(pars[6],TailleX2,TailleY2,1);
       deuxd.spect[idx2].typeX:=deuxd.spect[idx1].typeX;deuxd.spect[idx2].typeY:=deuxd.spect[idx1].typeY;
       { remplissage du nouveau spectre }
       { scan du premier spectre }
       for i:=0 to TailleX1-1 do
        for j:=0 to TailleY1-1 do
          begin
            xaux:=deuxd.spect[idx1].data[i,j,0].x;
            yaux:=deuxd.spect[idx1].data[i,j,0].y;
            zaux:=deuxd.spect[idx1].data[i,j,0].z;
            if (xaux>=par[2]) and (xaux<=par[4]) and (yaux>=par[3]) and (yaux<=par[5]) then
            begin
            deuxd.spect[idx2].data[round((xaux-par[2])/xstep1),round((yaux-par[3])/ystep1),0].X:=xaux;
            deuxd.spect[idx2].data[round((xaux-par[2])/xstep1),round((yaux-par[3])/ystep1),0].Y:=yaux;
            deuxd.spect[idx2].data[round((xaux-par[2])/xstep1),round((yaux-par[3])/ystep1),0].Z:=zaux;
            end;
          end;
       interpreteurform.timer1.enabled:=true;
    end;

    { creation des echelles en X pour les graph 2D }
    { INPUT : pars[1] le nom d'un spectre 2D               }
    {         pars[2] la premire valeur                   }
    {         pars[3] le pas                               }
    {         pars[4] le nouveau type des data             }
    { OUTPUT : les champs .x des data sont mis a jour      }
    function SetX1D:integer;far;
    var i,ind:integer;
    begin
       ind:=und.indexof(pars[1]);
       for i:=0 to und.spect[ind].X-1 do
          und.spect[ind].data[i,0,0].x:=par[2]+i*par[3];
       und.spect[ind].typeX:=pars[4];
    end;

    { creation des echelles en X pour les graph 2D }
    { INPUT : pars[1] le nom d'un spectre 2D               }
    {         pars[2] la premire valeur                   }
    {         pars[3] le pas                               }
    {         pars[4] le nouveau type des data             }
    { OUTPUT : les champs .x des data sont mis a jour      }
    function SetX2D:integer;far;
    var i,j,ind:integer;
    begin
       ind:=deuxd.indexof(pars[1]);
       for j:=0 to deuxd.spect[ind].Y-1 do
          for i:=0 to deuxd.spect[ind].X-1 do
             deuxd.spect[ind].data[i,j,0].x:=par[2]+i*par[3];
       deuxd.spect[ind].typeX:=pars[4];
    end;

    { creation des echelles en X pour les graph 2D }
    { INPUT : pars[1] le nom d'un spectre 2D               }
    {         pars[2] la premire valeur                   }
    {         pars[3] le pas                               }
    { OUTPUT : les champs .x des data sont mis a jour      }
    function SetY2D:integer;far;
    var i,j,ind:integer;
    begin
       ind:=deuxd.indexof(pars[1]);
       for i:=0 to deuxd.spect[ind].X-1 do
          for j:=0 to deuxd.spect[ind].Y-1 do
             deuxd.spect[ind].data[i,j,0].y:=par[2]+j*par[3];
       deuxd.spect[ind].typeY:=pars[4];
    end;

    { remappage d'un spectre 2D des coordonnes (theta in;theta out) verx (Qz,Qx) }
    { on suppose Tin en X et Tout en Y    en DEGRES !!!                           }
    { les units de q sont les units de 1/lambda                                 }
    { INPUT : pars[1], spectre 2D a remapper                                      }
    {         par[2] lambda                                                       }
    {         par[3], qxmin; par[4], qxpas; par[5], qxmax;  (en nm-1)          }
    {         par[6], qxmin; par[7], qxpas; par[8], qxmax;                     }
    {         pars[9], le nom du nouveau spectre avec les data qx,qy              }
    { OUTPUT : on cre un nouveau spectre 2D avec les coordonnes qx,qy           }
    { REM : il faut que les .x et .y soit bien initialiss                        }
    { IL MANQUE LA NORMALISATION POUR LE MOMENT }
    { IL SEMBLE QU'ON COMPTE PLUS DE COUPS QUE DANS LE SPECTRE DE DEPART !!! }
    function Remap2DtoQxQz:integer;far
    var i,j,ind,qind:integer;
        qx,qy,qz,qXmin,qXmax,qXpas,qYmin,qYmax,qYpas:double;
        cste,ti,tf,auxP,auxM:double;
        ii,jj,iimax,jjmax:integer;
        dti,dtf,dqx,dqy,dqxdti,dqxdtf,dqydti,dqydtf:double;           { pas en theta initial et theta final }
    begin
       cste:=4*pi/par[2];
       ind:=deuxd.indexof(pars[1]); { spectre 2D a traiter }
       dti:=abs(deuxd.spect[ind].data[1,0,0].x-deuxd.spect[ind].data[0,0,0].x);
       dtf:=abs(deuxd.spect[ind].data[0,1,0].y-deuxd.spect[ind].data[0,0,0].y);
       { creation du nouveau spectre }
       qXmin:=par[3];qXpas:=par[4];qXmax:=par[5];
       qYmin:=par[6];qYpas:=par[7];qYmax:=par[8];
       iimax:=round((qxmax-qxmin)/qxpas);jjmax:=round((qymax-qymin)/qypas);
       qind:=deuxd.addspectre(pars[9],iimax,jjmax,1);
{       deuxd.spect[qind].typeX:='1/[L]';
       deuxd.spect[qind].typeY:='1/[L]'; }
       { en attendant que les projections acceptent les types autres que 'raw' }
       deuxd.spect[qind].typeX:='raw';
       deuxd.spect[qind].typeY:='raw';

       { initialisation des champs .X et .y pour le spectre en qx qz }
       for i:=0 to deuxd.spect[qind].X-1 do
          for j:=0 to deuxd.spect[qind].Y-1 do
          begin
             deuxd.spect[qind].data[i,j,0].x:=qxmin+i*qxpas;
             deuxd.spect[qind].data[i,j,0].y:=qymin+j*qypas;
          end;
       { on scan les points du spectre en t in  et t out }
       for i:=0 to deuxd.spect[ind].X-1 do
          for j:=0 to deuxd.spect[ind].Y-1 do
          begin
               ti:=deuxd.spect[ind].data[i,j,0].x*pi/180;
               tf:=deuxd.spect[ind].data[i,j,0].y*pi/180;
               auxP:=(ti+tf)/2;auxM:=(ti-tf)/2;
               { ces formules ne s'appliquent que pour les faisceaux reflechis !!! }
               { il y a des corrections a faire pour les faisceaux transmis   }
               qx:=cste*sin(auxP)*cos(auxM); { ACHTUNG, ca correspond a qz pour notations F.O. }
               qy:=cste*sin(auxP)*sin(auxM); { ACHTUNG ca correspond  qx pour notations F.O. }
               dqxdti:=0.5*cste*(cos(auxP)*cos(auxM)-sin(auxP)*sin(auxM));
               dqxdtf:=0.5*cste*(cos(auxP)*cos(auxM)+sin(auxP)*sin(auxM));
               dqydti:=0.5*cste*(cos(auxP)*sin(auxM)+sin(auxP)*cos(auxM));
               dqydtf:=0.5*cste*(cos(auxP)*sin(auxM)-sin(auxP)*cos(auxM));
               dqx:=dqxdti*dti+dqxdtf*dtf;dqy:=dqydti*dti+dqydtf*dtf;
               { dans quelle cellule doit-on mettre ces points }
               { il faut verifier si ca rentre dans le graph 2D }
               ii:=round((qx-qxmin)/qxpas);jj:=round((qy-qymin)/qypas);
               if (ii>=0) and (ii<iimax) and (jj>=0) and (jj<jjmax)
               then begin
                    { version normalise, mais ca pose des problmes pour le signe des dqxdti }
                     deuxd.spect[qind].data[ii,jj,0].z:=deuxd.spect[qind].data[ii,jj,0].z+deuxd.spect[ind].data[i,j,0].z/abs(dqx*dqy);
                    {deuxd.spect[qind].data[ii,jj,0].z:=deuxd.spect[qind].data[ii,jj,0].z+deuxd.spect[ind].data[i,j,0].z; }
                    end;
               { verification que la normalisation des surfaces des espaces reciproques est bonne }
          end;
    end;
{ ****** procdures agissant sur les spectres 3D }
    function DelSpectre3D:integer;far
    begin
         troisd.delete(pars[1]);
    end;
    function AddSpectre3D:integer;far;
    begin
         troisd.addition(pars[1],pars[2],pars[3]);
    end;
{Somme Total sur le spectre   
    pars[1] Nom3D
    par[2] nom variable parseur
    le rsultat est stok dans la boite noire
    ou dans la variable du parseur pars[6]si <>'' ex "var"}
    function IntegraleSpectre3D:integer;far
    var vind,i,j,k:integer;
        temp:real;
    begin
    vind:=troisd.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=0;
       for i:=0 to troisd.spect[vind].X-1  do
          for j:=0 to troisd.spect[vind].Y-1  do
              for k:=0 to troisd.spect[vind].LT-1  do
              temp:=temp+troisd.spect[vind].data[i,j,k].Z;

       if pars[2]<>'' then interpreteurform.parser1.setvariable(pars[2],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;

    end;
    function ReadMoni3D:integer;far
    var vind:integer;
        temp:real;

    begin
    vind:=troisd.indexof(pars[1]);
    if vind>0 then
       begin
       temp:=troisd.spect[vind].moniteur;
       if pars[2]<>'' then interpreteurform.parser1.setvariable(pars[2],temp)
       else  boitnoir.receivetext(floattostr(temp));
       end;
    end;
  {procedure permettant de separer un spectre troisd en spectre 2d (selon la dim LT)}
  {INPUT pars[1] : nom du spectre 3D
         pars[2] : nom du spectres 2D
         par[3]  : numero de frame 1<..<LT
         pars[4] : mode de calcul du moniteur
                   norm/nombre : divise le moniteur par le nombre de frame
                   norm/inter : multiplie le moniteur par l'intervale lt[i]-lt[i-1]/Temps Total
                   rien copie directement le moniteur}
  function Spectre3DTo2D:integer;far
  var vind3D,vind2D,i,j,l:integer;
      X,Y,LT:integer;
      delta:real;
  begin
  vind3d:=troisd.indexof(pars[1]);
  if vind3d>0 then
  begin
  X:=troisd.spect[vind3D].X;
  Y:=troisd.spect[vind3D].Y;
  LT:=troisd.spect[vind3D].LT;
  l:=round(Par[3])-1;
  if (l>=0) and (l<=LT-1) then
  begin
    {cration du spectre 2D recepteur}
    vind2D:=deuxd.addspectre(pars[2],X,Y,1);
    {chargement des data et echelle X,Y}
    for i:=0 to X-1 do
       for j:=0 to Y-1 do
          begin
          deuxd.spect[vind2D].data[i,j,0].x:=troisd.spect[vind3D].data[i,j,l].x;
          deuxd.spect[vind2D].data[i,j,0].y:=troisd.spect[vind3D].data[i,j,l].y;
          deuxd.spect[vind2D].data[i,j,0].z:=troisd.spect[vind3D].data[i,j,l].z;
          deuxd.spect[vind2D].data[i,j,0].lt:=troisd.spect[vind3D].data[i,j,l].lt;
          end;
    {chargement des infos}
    deuxd.spect[vind2D].comment:=troisd.spect[vind3D].comment;
    deuxd.spect[vind2D].typeX:=troisd.spect[vind3D].typeX;
    deuxd.spect[vind2D].typeY:=troisd.spect[vind3D].typeY;
    deuxd.spect[vind2D].typeLT:=troisd.spect[vind3D].typeLT;
    {chargement des conditions exprimentales}
    for i:=0 to troisd.spect[vind3D].ExpCondNbr-1 do
       deuxd.spect[vind2D].SetExpCond(troisd.spect[vind3D].experimentalConditions[i].name,troisd.spect[vind3D].experimentalConditions[i].value);

    deuxd.spect[vind2D].SetExpCond('lt',troisd.spect[vind3D].data[0,0,l].lt);

    {chargement du moniteur: 3 options en fonction de pars[3]}
    if pars[4]='norm/nombre' then
        begin {normalisation par le nombre de slice}
        deuxd.spect[vind2D].moniteur:=troisd.spect[vind3D].moniteur/LT; 
        deuxd.spect[vind2D].SetExpCond('NormMoniteur',1);
        end
    else
        if  pars[4]='norm/inter' then
            begin  {normalisation par la dure de la frame}
            if l=0 then delta:=troisd.spect[vind3D].data[0,0,l].lt
               else  delta:=troisd.spect[vind3D].data[0,0,l].lt-troisd.spect[vind3D].data[0,0,l-1].lt;
            deuxd.spect[vind2D].moniteur:=troisd.spect[vind3D].moniteur*delta/troisd.spect[vind3D].data[0,0,troisd.spect[vind3D].LT-1].lt;
            deuxd.spect[vind2D].SetExpCond('NormMoniteur',2);
            end
        else
            begin {pas de normalisation}
            deuxd.spect[vind2D].moniteur:=troisd.spect[vind3D].moniteur;
            deuxd.spect[vind2D].SetExpCond('NormMoniteur',0);
            end;
    end;
  end;
  end;

  { lecture d'un spectre mesure sur D17 et sauvegard en format LAMP }
  function ReadLAMPD17:integer;far
  var vind:integer;
      temp:real;
  begin
      Graph2DForm.LectureLAMPD17File(pars[1],pars[2]);
  end;

{ calcul de la transforme de FOurier }
{ INPUT : pars[1] nom du spectre (pour le moment 1D par defaut }
{         par[2] le premier point, par[3], la longueur du sub-vecteur a transformer }
{ OUTPUT : les spectres transforms sont sorties en MySpectre_FFT }
  function FFT:integer;far
  begin
      und.FFT(pars[1],round(par[2]),round(par[3]),pars[1]+'_FFT');
  end;

{ calcul du moduel d'un vecteur }
  function ModuleVect1D:integer;far
  begin
      und.Module(pars[1],pars[2]);
  end;

{ ======================================================== }
{ lecture/ecriture bas niveau sur la carte GPIB  }

{ initialisation de la carte GPIB }
{ adresse code en dur  0        }
  function IEInit:integer;far
  begin
{     GPIBinitialize(0,0); }
     setport(0,$1400);
     gpibinitialize(21,0);
     setoutputeos(13,0);
     setinputeos(13);
     settimeout(1000);
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], command as string }
{         pars[3]; answer as string  }
{         par[4]; status as long     }
{ ACHTUNG : il y a un probleme avec les virgules dans les chaines !!!!! }
{ c'est lu comme un changement de paramtre !!!                         }
  function IELaunch:integer;far
  var s:string;
      address:integer;
  begin
     address:=StrToInt(pars[1]);    { extended me pose des problmes ?!? }
     GPIBSend(address,pars[2]);
     GPIBRead(address,s,255);
     boitnoir.receivetext('IEAnswer = '+s);
     boitnoir.receivetext('IEStatus = '+IntToStr(GPIBStatus));
     interpreteurform.parser1.setvariable('IEStatus',gpibstatus);
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], command as string }
{         par[3]; nbr of expected bytes 'ie_expectedbytes' }
{         pars[4], nom du tableau de sortie             }
{ pour le moment limite  65K                          }
  function IEGetLongArray:integer;far
  var s:string;
      address:integer;
      tab:PSDarray65k;
      temp:string;
      lendem,len:longint;
      status:integer;
      i,indexSpectre:integer;
  begin
     lendem:=StrToInt(pars[3]);
     address:=StrToInt(pars[1]);    { extended me pose des problmes ?!? }
     temp:='UNL UNT MLA TALK0'+ inttostr(address);
     GpibSend(address,pars[2]);
     GPIBtransmit(temp);      {arret de tous les dialogues sur GPIB}
     rarray32b(tab,lendem,len,status);
     GPIBtransmit('UNL UNT');
     boitnoir.receivetext('IElength = '+IntToStr(len));
     boitnoir.receivetext('IEstatus = '+IntToStr(GPIBStatus));
     interpreteurform.parser1.setvariable('IEStatus',gpibstatus);
     { remplissage du spectre a partir des data de tab }
     indexSpectre:=und.addspectre(pars[4],len,1,1);
     for i:=0 to len-1 do
        begin und.spect[indexspectre].data[i,0,0].x:=i;und.spect[indexspectre].data[i,0,0].z:=tab[i+1] end;
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], first adress }
{         pars[3], last address }
{         pars[4], nom du tableau de sortie             }
{ pour le moment limite  65K                          }
  function IEGetArray1D:integer;far
  var s:string;
      address:integer;
      tab:PSDarray65k;
      temp:string;
      lendem,len:longint;
      status:integer;
      i,indexSpectre:integer;
      commande:string;
  begin
     lendem:=(StrToInt(pars[3])-StrToInt(pars[2])+1)*4;
     boitNoir.receivetext(intToStr(lendem));
     address:=StrToInt(pars[1]);    { extended me pose des problmes ?!? }
     temp:='UNL UNT MLA TALK0'+ inttostr(address);
     commande:='T'+pars[2]+','+pars[3];
     GpibSend(address,commande);
     boitNoir.receivetext(commande);
     GPIBtransmit(temp);      {arret de tous les dialogues sur GPIB}
     rarray32b(tab,lendem,len,status);
     GPIBtransmit('UNL UNT');
     boitnoir.receivetext('IElength = '+IntToStr(len));
     boitnoir.receivetext('IEstatus = '+IntToStr(GPIBStatus));
     interpreteurform.parser1.setvariable('IEStatus',gpibstatus);
     { remplissage du spectre a partir des data de tab }
     indexSpectre:=und.addspectre(pars[4],len,1,1);
     for i:=0 to len-1 do
        begin und.spect[indexspectre].data[i,0,0].x:=i;und.spect[indexspectre].data[i,0,0].z:=tab[i+1] end;
  end;

{ INPUT : par[1], IEEE Address;                 }
{         pars[2], first adress                 }
{         pars[3], last address                 }
{         pars[4], taille en X                  }
{         pars[5], taille en Y                  }
{         pars[6], nom du tableau de sortie     }
{ pour le moment limite  65K                   }
  function IEGetArray2D:integer;far
  var s:string;
      address:integer;
      tab:PSDarray65k;
      temp:string;
      lendem,len:longint;
      status:integer;
      i,j,indexSpectre:integer;
      commande:string;
      x,y:integer;
  begin
     x:=StrToInt(pars[4]);y:=StrToInt(pars[5]);
     lendem:=(StrToInt(pars[3])-StrToInt(pars[2])+1)*4;
     boitNoir.receivetext(intToStr(lendem));
     address:=StrToInt(pars[1]);    { extended me pose des problmes ?!? }
     temp:='UNL UNT MLA TALK0'+ inttostr(address);
     commande:='T'+pars[3]+','+pars[4];
     GpibSend(address,commande);
     boitNoir.receivetext(commande);
     GPIBtransmit(temp);      {arret de tous les dialogues sur GPIB}
     rarray32b(tab,lendem,len,status);
     GPIBtransmit('UNL UNT');
     boitnoir.receivetext('IElength = '+IntToStr(len));
     boitnoir.receivetext('IEstatus = '+IntToStr(GPIBStatus));
     interpreteurform.parser1.setvariable('IEStatus',gpibstatus);
     { remplissage du spectre 2D a partir des data de tab }
     indexSpectre:=deuxd.addspectre(pars[6],X,Y,1);
     for i:=0 to X-1 do
        for j:=0 to Y-1 do
           begin
           deuxd.spect[indexspectre].data[i,j,0].x:=i;
           deuxd.spect[indexspectre].data[i,j,0].y:=j;
           deuxd.spect[indexspectre].data[i,j,0].z:=tab[i*Y+j+1]
           end;
  end;

{ INPUT : par[1], IEEE Address;      }
{         pars[2], command as string }
{         par[3]; nbr of bytes to send }
{         pars[4]; nom du tableau a envoyer }
  function IESendLongArray:integer;far
  var s:string;
      address:integer;
      tab:PSDarray65k;
      temp:string;
      lendem,len:longint;
      status:integer;
      i,indexSpectre:integer;
  begin
     lendem:=StrToInt(pars[3]);
     address:=StrToInt(pars[1]);    { extended me pose des problmes ?!? }
     { remplissage du tableau a envoyer }
     { remplissage du spectre a partir des data de tab }
     indexSpectre:=und.indexof(pars[4]);
     for i:=0 to len-1 do begin tab[i+1]:=round(und.spect[indexspectre].data[i,0,0].z) end;
     temp:='UNL UNT MLA TALK0'+ inttostr(address);
     GpibSend(address,pars[2]);
     GPIBtransmit(temp);      {arret de tous les dialogues sur GPIB}
     { envoie des data }
     tarray32(tab,lendem,len,status);
     GPIBtransmit('UNL UNT');
     boitnoir.receivetext('IElength = '+IntToStr(len));
     boitnoir.receivetext('IEstatus = '+IntToStr(GPIBStatus));
     interpreteurform.parser1.setvariable('IEStatus',gpibstatus);
  end;

{ ============================================== }


{ ============================================== }



{****************************************************************************}
{                      FIN De L'implementation des fonctions interpreteur}
{************}
{                      DEBUT de l'interpreteur}
{****************************************************************************}


{$R *.DFM}

procedure Tinterpreteurform.FormCreate(Sender: TObject);
var
i:integer;
begin
left:=0;top:=401;width:=520;height:=270;
seqon:=0;
actlig:=tstringlist.create;
actligf:=tstringlist.create;
variable:=tstringlist.create;
varpar:=tstringlist.create;
ordre:=tstringlist.create;
labels:=tstringlist.create;
for i:=0 to 200 do param[i]:=tvaripar.create;
mem1.filter:='Squences (*.seq)|*.seq|textes (*.txt)|*.txt';
mem1.defaultext:='.seq';
mem1.directory:=repseq;
{*********  Debut des dclaration propre  PILOTAGE}
{$IFDEF PILOTAGE }
{variables de comptage}
if suiviPRISMForm<>nil then begin
addvariable('Nupup',0,0,0,0,'',tobject(@rien));
addvariable('Nupdo',1,0,0,0,'',tobject(@rien));
addvariable('Ndoup',2,0,0,0,'',tobject(@rien));
addvariable('Ndodo',3,0,0,0,'',tobject(@rien));
addvariable('Mupup',0,0,0,0,'',tobject(@rien));
addvariable('Mupdo',1,0,0,0,'',tobject(@rien));
addvariable('Mdoup',2,0,0,0,'',tobject(@rien));
addvariable('Mdodo',3,0,0,0,'',tobject(@rien));
addvariable('Tupup',0,0,0,0,'',tobject(@rien));
addvariable('Tupdo',1,0,0,0,'',tobject(@rien));
addvariable('Tdoup',2,0,0,0,'',tobject(@rien));
addvariable('Tdodo',3,0,0,0,'',tobject(@rien));
addvariable('up',4,0,0,0,'',tobject(@rien));
addvariable('do',5,0,0,0,'',tobject(@rien));
addvariable('temps',4,0,0,0,'',tobject(@fixtemps));
addvariable('Tu1',1,0,0,0,'',tobject(@comptcond));
addvariable('Tu2',2,0,0,0,'',tobject(@comptcond));
addvariable('Tu3',3,0,0,0,'',tobject(@comptcond));
addvariable('Tu4',4,0,0,0,'',tobject(@comptcond));
addvariable('Cl1',5,0,0,0,'',tobject(@comptcond));
addvariable('Cl2',6,0,0,0,'',tobject(@comptcond));
addvariable('Cl3',7,0,0,0,'',tobject(@comptcond));
addvariable('Cl4',8,0,0,0,'',tobject(@comptcond));
end;
{variables RMN}
if RMNacqui<>nil then begin
addvariable('Polar',0,0,0,0,'',tobject(@rien));
addvariable('temps',0,0,0,0,'',tobject(@rien));
end;
{variables acquisition 2D}
if comptage2Dform<>nil then begin
addvariable('acq2D',0,0,0,0,'',tobject(@rien));
end;
{variables internes}
addvariable('timer',100,1,0,0,'',tobject(@fixtimer));
{ajout des moteurs}
tablemot.open;
if tabmot<>nil then addmotorlist;
{l'ensemble des fonctions se rajoutent dans les fonctions possibles ici}
ordre.addobject('acqsimple',tobject(@acqsimple));
ordre.addobject('acqsimple2D',tobject(@acqsimple2D));
ordre.addobject('StartPolAlt',tobject(@StartPolAlt));
ordre.addobject('testacqsimple2D',tobject(@testacqsimple2D));
ordre.addobject('initTOF',tobject(@initTOF));
ordre.addobject('startTOF',tobject(@startTOF));
ordre.addobject('readdataTOF',tobject(@readdataTOF));
ordre.addobject('waitchamp',tobject(@waitchamp));
ordre.addobject('waittemp',tobject(@waittemp));
ordre.addobject('waitmotors',tobject(@waitmotors));
ordre.addobject('pause',tobject(@pause));
ordre.addobject('addconditions',tobject(@addcond));
ordre.addobject('addangles',tobject(@addangles));
ordre.addobject('polarisation',tobject(@polarisation));
ordre.addobject('typecompt',tobject(@typcompt));
ordre.addobject('flippers',tobject(@fixflip));
ordre.addobject('setcurrent',tobject(@SetCurrent));
ordre.addobject('getvoltage',tobject(@GetVoltage));
ordre.addobject('RMNirrad',tobject(@RMNirrad));
ordre.addobject('RMNsaturation',tobject(@RMNsaturation));
ordre.addobject('RMNlitpolar',tobject(@RMNlitpolar));
ordre.addobject('RMNavecBase',tobject(@RMNavecBase));
ordre.addobject('addpol',tobject(@addpol));
ordre.addobject('clearvisupol',tobject(@clearvisupol));
ordre.addobject('fixCourantBoss',tobject(@fixIboss));
ordre.addobject('setFieldL',tobject(@setFieldL));
ordre.addobject('setCurrentF1H',tobject(@setCurrentF1H));
ordre.addobject('setCurrentF1V',tobject(@setCurrentF1V));
ordre.addobject('setCurrentF2H',tobject(@setCurrentF2H));
ordre.addobject('setCurrentF2V',tobject(@setCurrentF2V));

{$ENDIF }
{*********  Fin des dclaration propre  PILOTAGE}
ordre.addobject('addpt',tobject(@addpt));
ordre.addobject('addpoint1D',tobject(@addpoint1D));
ordre.addobject('addcomment',tobject(@addcomment));
ordre.addobject('delay',tobject(@delay));
ordre.addobject('clearspectre',tobject(@clearspectre));
ordre.addobject('addspectre',tobject(@addspectre));
{ manipulations des spectres de data }
{ fonctions agissant sur les spectres 1D }
ordre.addobject('delSpectre1D',tobject(@delSpectre1D));
ordre.addobject('addSpectre1D',tobject(@addSpectre1D));
ordre.addobject('subSpectre1D',tobject(@subSpectre1D));
ordre.addobject('multSpectre1D',tobject(@multSpectre1D));
ordre.addobject('divSpectre1D',tobject(@divSpectre1D));
ordre.addobject('scalAddSpectre1D',tobject(@ScalAddSpectre1D));
ordre.addobject('scalSubSpectre1D',tobject(@ScalSubSpectre1D));
ordre.addobject('scalMultSpectre1D',tobject(@ScalMultSpectre1D));
ordre.addobject('scalDivSpectre1D',tobject(@ScalDivSpectre1D));
{ aliases }
ordre.addobject('del1D',tobject(@delSpectre1D));
ordre.addobject('add1D',tobject(@addSpectre1D));
ordre.addobject('sub1D',tobject(@subSpectre1D));
ordre.addobject('mult1D',tobject(@multSpectre1D));
ordre.addobject('div1D',tobject(@divSpectre1D));
ordre.addobject('scalAdd1D',tobject(@ScalAddSpectre1D));
ordre.addobject('scalSub1D',tobject(@ScalSubSpectre1D));
ordre.addobject('scalMult1D',tobject(@ScalMultSpectre1D));
ordre.addobject('scalDiv1D',tobject(@ScalDivSpectre1D));
ordre.addobject('sqrt1D',tobject(@Sqrt1D));
ordre.addobject('Smooth1D',tobject(@Smooth1D));
ordre.addobject('Smooth2D',tobject(@Smooth2D));
{ fonctions agissant sur les spectres 2D }
ordre.addobject('delSpectre2D',tobject(@delSpectre2D));
ordre.addobject('addSpectre2D',tobject(@addSpectre2D));
ordre.addobject('subSpectre2D',tobject(@subSpectre2D));
ordre.addobject('multSpectre2D',tobject(@multSpectre2D));
ordre.addobject('divSpectre2D',tobject(@divSpectre2D));
ordre.addobject('scalAddSpectre2D',tobject(@ScalAddSpectre2D));
ordre.addobject('scalSubSpectre2D',tobject(@ScalSubSpectre2D));
ordre.addobject('scalMultSpectre2D',tobject(@ScalMultSpectre2D));
ordre.addobject('scalDivSpectre2D',tobject(@ScalDivSpectre2D));
ordre.addobject('NormMoniSpectre2D',tobject(@NormMoniSpectre2D));
{ aliases }
ordre.addobject('del2D',tobject(@delSpectre2D));
ordre.addobject('add2D',tobject(@addSpectre2D));
ordre.addobject('sub2D',tobject(@subSpectre2D));
ordre.addobject('mult2D',tobject(@multSpectre2D));
ordre.addobject('div2D',tobject(@divSpectre2D));
ordre.addobject('scalAdd2D',tobject(@ScalAddSpectre2D));
ordre.addobject('scalSub2D',tobject(@ScalSubSpectre2D));
ordre.addobject('scalMult2D',tobject(@ScalMultSpectre2D));
ordre.addobject('scalDiv2D',tobject(@ScalDivSpectre2D));
ordre.addobject('sqrt2D',tobject(@Sqrt2D));
{ fonctions de projection }
ordre.addobject('ProjectionHSpectre2D',tobject(@ProjectionHSpectre2D));
ordre.addobject('ProjectionVSpectre2D',tobject(@ProjectionVSpectre2D));
ordre.addobject('ProjH',tobject(@ProjectionHSpectre2D));
ordre.addobject('ProjV',tobject(@ProjectionVSpectre2D));
ordre.addobject('IntegraleSpectre1D',tobject(@IntegraleSpectre1D));
ordre.addobject('IntegraleSpectre2D',tobject(@IntegraleSpectre2D));
ordre.addobject('SommeCirculaireSpectre2D',tobject(@SommeCirculaireSpectre2D));
ordre.addobject('SommeDNPA',tobject(@SommeDNPA));
ordre.addobject('MasqueSecteur',tobject(@MasqueSecteur));
ordre.addobject('Barycentre2D',tobject(@Barycentre2D));
{fonctions de gestion du tableau des conditions exprimentalles et commentaire}
ordre.addobject('SetExpCond',tobject(@SetExpCond));
ordre.addobject('SetComment',tobject(@SetComment));
ordre.addobject('Setstring',tobject(@Setstring));
ordre.addobject('Settab',tobject(@Settab));
{ fonctions de lecture de spectres }
ordre.addobject('readspectre2D',tobject(@readspectre2D));
ordre.addobject('lectureFichierHADAS',tobject(@lectureFichierHADAS));
ordre.addobject('openspectre',tobject(@openspectre));
ordre.addobject('openNeXuS',tobject(@openNeXuS));
ordre.addobject('SaveSpectre',tobject(@SaveSpectre));
ordre.addobject('openPAXY',tobject(@openPAXY));
{ fonction de concatnation de spectres 1D }
ordre.addobject('concat1D',tobject(@concat1D));
ordre.addobject('concat2D',tobject(@concat2D));
ordre.addobject('extract2D',tobject(@extract2D));
ordre.addobject('extract1D',tobject(@extract1D));
ordre.addobject('Convert1Dto2Drow',tobject(@Convert1Dto2Drow));
ordre.addobject('Convert1Dto2DrowY',tobject(@Convert1Dto2DrowY));
ordre.addobject('Convert1Dto2Dcol',tobject(@Convert1Dto2Dcol));
ordre.addobject('Convert1Dto2DcolX',tobject(@Convert1Dto2Dcol));
ordre.addobject('appendCol',tobject(@appendCol));
ordre.addobject('appendColX',tobject(@appendCol));
ordre.addobject('appendRow',tobject(@appendRow));
ordre.addobject('appendRowY',tobject(@appendRowY));
ordre.addobject('resize1D',tobject(@resize1D));
{ procdures  amliorer ET/OU finir }
ordre.addobject('saveToASCII1D',tobject(@saveToASCII1D));
ordre.addobject('saveToASCII2D',tobject(@saveToASCII2D));
{ ====================================== }
ordre.addobject('setX1D',tobject(@setX1D));
ordre.addobject('setX2D',tobject(@setX2D));
ordre.addobject('setY2D',tobject(@setY2D));
ordre.addobject('remap2DtoQxQz',tobject(@Remap2DtoQxQz));
{fonctions sur spectres 3D}
ordre.addobject('del3D',tobject(@delSpectre3D));
ordre.addobject('add3D',tobject(@addSpectre3D));
ordre.addobject('IntegraleSpectre3D',tobject(@IntegraleSpectre3D));
ordre.addobject('ReadMoni3D',tobject(@ReadMoni3D));
ordre.addobject('Spectre3DTo2D',tobject(@Spectre3DTo2D));
ordre.addobject('ReadLAMPD17',tobject(@ReadLAMPD17));

ordre.addobject('FFT',tobject(@FFT));
ordre.addobject('Module',tobject(@ModuleVect1D));

{ GPIB } { fonctions spcifiques au programm eEuroPSD driver }
ordre.addobject('IEInit',tobject(@IEInit));
ordre.addobject('IELaunch',tobject(@IELaunch));
ordre.addobject('IEGetLongArray',tobject(@IEGetLongArray));
ordre.addobject('IESendLongArray',tobject(@IESendLongArray));
ordre.addobject('IEGetArray1D',tobject(@IEGetArray1D));
ordre.addobject('IEGetArray2D',tobject(@IEGetArray2D));


{ cration des labels de "la"  "lb" }
for i:=1 to 26 do
begin labels.add('L'+chr(i+64));labelstab[i]:=0;end;
flagwaitchamp:=false;
flagwaittemp:=false;
flagwaitacquis:=false;
flagwaitacquisPSD:=false;
flagwaitmotor:=false;
end;

procedure Tinterpreteurform.addmotorlist;
begin
{$IFDEF PILOTAGE }
tablemot.first;
while not tablemot.eof do begin
addvariable(tablemotnomcourt.value,0,tablemotindex.value,3,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'dep',tablemotdepart.value,tablemotindex.value,4,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'fin',tablemotfin.value,tablemotindex.value,5,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'inc',tablemotinc.value,tablemotindex.value,6,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'zero',tablemotzero.value,tablemotindex.value,7,0,'',tobject(@settable));
addvariable(tablemotnomcourt.value+'val',0,tablemotindex.value,8,0,'',tobject(@settable));
tablemot.next;
end;
{$ENDIF }
end;

{ cration d'une nouvelle variable }
procedure Tinterpreteurform.addvariable(name:string;value:integer;p1:integer;p2:double;p3:double;p4:string;tpro:tobject);
var
i:integer;
begin
parser1.setvariable(name,value);
i:=variable.AddObject(name,tpro);
param[i].p1:=p1;param[i].p2:=p2;param[i].p3:=p3;param[i].p4:=p4;
varpar.AddObject(name,@param[i]);
end;


procedure Tinterpreteurform.setvaleur(name:string;value:integer);
begin
parser1.setvariable(name,value);
end;

{ lancement d'une squence de script
{ INPUT: utilise le text du memo en cours }
procedure Tinterpreteurform.ScriptExecuteButtonClick(Sender: TObject);
begin
actligf.text:=mem1.memo.text;
pretraitement;
execution;
end;

procedure Tinterpreteurform.ScriptExecuteSelectionButtonClick(Sender: TObject);
begin
actligf.text:=mem1.memo.seltext;
pretraitement;
execution;
end;

{prtraitement traite les inclusions}
procedure Tinterpreteurform.pretraitement;
var
i,tf:integer;
fich:tstringlist;
s:string;
begin
for i:=1 to 26 do labelstab[i]:=0;
actlig.clear;
fich:=tstringlist.create;
tf:=1;
{ajout des inclusions}
while tf<>0 do begin
tf:=0;
for i:=0 to actligf.count-1 do begin
{ajout du ; oubli}
if pos(';',actligf.strings[i])<=0 then actligf.strings[i]:=actligf.strings[i]+';';
actligf.strings[i]:=copy(actligf.strings[i],1,pos(';',actligf.strings[i]));
if copy(actligf.strings[i],1,4)<>'inc=' then begin
actlig.add(actligf.strings[i]);
end else begin
filename:=copy(actligf.strings[i],5,pos(';',actligf.strings[i])-5);
fich.loadfromfile(repseq+filename+seqext);
actlig.addstrings(fich);
tf:=1;
end;
end;
if tf<>0 then begin
actligf.text:=actlig.text;
actlig.clear;
end;
end;
{fin d'ajout des inclusions}
{assignation des labels}
for i:=0 to actlig.count-1 do begin
s:=actlig.Strings[i];
if (copy(s,3,1)=':') and (labels.indexof(copy(s,1,2))>=0) then
labelstab[labels.indexof(copy(s,1,2))]:=i;
end;
fich.free;
end;

procedure tinterpreteurform.execution {test d'une squence pour criture};
begin
{dbut de la realisation}
seqlig:=0;
seqon:=1;
flagwaitacquis:=false;
flagwaitacquisPSD:=false;
flagwaitEnergizing:=false;
timer1.enabled:=true;
ScriptStatus.caption:='Running...';
end;


function Tinterpreteurform.traitstring(s:string;ind:integer):integer;
label debut;
var
i,j:integer;
s2,sn,sval,nomvar:string;
retour:integer;
f:function(name:string):integer;
g:function:integer;
pari:string;
test,tu:boolean;
x,mon,tem:integer;
parCrt:string;
paraEnd,inString,inReal:boolean;
vind1D,vind2D,vind3D:integer;
begin
{$IFDEF PILOTAGE }
{lecture de paramtres externes avant l'excution de l'instruction suivante}
{transfert des chelles de comptage}
suiviPRISMForm.getcomptage(1,x,mon,tem);
parser1.setvariable('Nupup',x);parser1.setvariable('Mupup',mon);
parser1.setvariable('Tupup',tem);
suiviPRISMForm.getcomptage(2,x,mon,tem);
parser1.setvariable('Ndodo',x);parser1.setvariable('Mdodo',mon);
parser1.setvariable('Tdodo',tem);
suiviPRISMForm.getcomptage(3,x,mon,tem);
parser1.setvariable('Nupdo',x);parser1.setvariable('Mupdo',mon);
parser1.setvariable('Tupdo',tem);
suiviPRISMForm.getcomptage(4,x,mon,tem);
parser1.setvariable('Ndoup',x);parser1.setvariable('Mdoup',mon);
parser1.setvariable('Tdoup',tem);
{$ENDIF }
retour:=ind+1;
debut:test:=false;
{chaine commentaire ou vide}
if (copy(s,1,1)=';') or (copy(s,2,1)=';') then test:=true;
{labels}
if (not test) and (copy(s,3,1)=':') and (labels.indexof(copy(s,1,2))>=0) then
s:=copy(s,4,length(s));
if (not test) and (copy(s,1,2)='if') then begin
{traitement du if}
 test:=true;
 if pos('then',s)<0 then
 begin
 timer1.enabled:=false;
 raise EvarError.Create('if sans then'+
 inttostr(ind)+':'+s);
 end;
 s2:=copy(s,4,pos('then',s)-5);
 tu:=false;
 if pos('>=',s2)>0 then begin
 sn:=copy(s2,1,pos('>=',s2)-1)+'-'+copy(s2,pos('>=',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value>=0 then tu:=true;
 end else
 if pos('<>',s2)>0 then begin
 sn:=copy(s2,1,pos('<>',s2)-1)+'-'+copy(s2,pos('<>',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value<>0 then tu:=true;
 end else
 if pos('<=',s2)>0 then begin
 sn:=copy(s2,1,pos('<=',s2)-1)+'-'+copy(s2,pos('<=',s2)+2,length(s2));
 parser1.expression:=sn;
 if parser1.value<=0 then tu:=true;
 end else
 if pos('=',s2)>0 then begin
 sn:=copy(s2,1,pos('=',s2)-1)+'-'+copy(s2,pos('=',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value=0 then tu:=true;
 end else
 if pos('<',s2)>0 then begin
 sn:=copy(s2,1,pos('<',s2)-1)+'-'+copy(s2,pos('<',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value<0 then tu:=true;
 end else
 if pos('>',s2)>0 then begin
 sn:=copy(s2,1,pos('>',s2)-1)+'-'+copy(s2,pos('>',s2)+1,length(s2));
 parser1.expression:=sn;
 if parser1.value>0 then tu:=true;
 end;
 if tu=true then begin
  s2:=copy(s,pos('then',s)+5,2);
  if labels.indexof(s2)>=0 then
  retour:=labelstab[labels.indexof(s2)] else
  begin
  s:=copy(s,pos('then',s)+5,length(s));goto debut;
  end;
 end;
end;
{fin du traitement if then}
if (not test) and (copy(s,1,4)='goto') then begin
s2:=copy(s,6,2);
  if labels.indexof(s2)>=0 then
  retour:=labelstab[labels.indexof(s2)];
test:=true;end;

{debut du traitement assignation de variables toto=10}
{ note on rajoute une condition pour eviter les provlmes avec les '=' qui se trouvent dans }
{ une chaine appele par une fonction. cad on ne lance le traitelment des assigantion que si la ligne }
{ ne correspond pas  un appel de fonciton : test = (pos('[',s)<=0)                         }
if (pos('=',s)>0) and (pos('[',s)<=0) and not test then begin { *** NEW *** }
test:=true;
sn:= copy(s,1,pos('=',s)-1);
if sn='' then raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
sval:=copy(s,pos('=',s)+1,pos(';',s)-pos('=',s)-1);
parser1.expression:=sval;
if not isvalidident(sn) then begin
timer1.enabled:=false;
raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
end else begin
try
if variable.indexof(sn)>=0 then begin
param[variable.indexof(sn)].value:=parser1.value;
@f:=variable.Objects[variable.indexof(sn)];
f(sn);
end;
parser1.setvariable(sn,parser1.value);
except begin
timer1.enabled:=false;
raise  EvarError.Create('variable non valide  la ligne '+
inttostr(ind)+':'+s);
end;
end;
end;
end;
{fin du traitement des variables}
{ ============================= }
{ test des fonctions appeles   }
if not test then begin
 if (pos('[',s)<=0) then
 begin
  pari:='';s2:=copy(s,1,pos(';',s)-1); { on recopie simplement le nom de la fonction appele }
 end else begin
  s2:=copy(s,1,pos('[',s)-1); { s2 recoit le nom de la fonction appele }
  pari:=copy(s,pos('[',s)+1,pos(']',s)-pos('[',s)-1);    {pari = argument d'une instruction}
 end;
if ordre.indexof(s2)=-1 then { test si la fontion appele existe vraiment }
begin
   timer1.enabled:=false;
   raise EvarError.Create('fonction non valide  la ligne '+
   inttostr(ind)+':'+s)
end
else begin
{traitement des parametres}
{clear du tableua de paramtres }
   for j:=1 to maxPara do
     begin pars[j]:='';par[j]:=0; end;
   j:=1; { index du paramtre en traitement }
   parCrt:='';i:=1; { i index courant dans la chaine }
   inString:=false;InReal:=false; { flags indiqaunt si on traite un para string ou real }
   if pari<>'' then
   begin
      { extraction du premier paramtre }
      { le premier paramtre est-il une string? }
      paraEnd:=false; { on est arriv au dernier paramtre }
      while (j<=maxPara) and (not(paraEnd)) do
      begin
      parCrt:='';inString:=false;InReal:=false;
      if pari[i]='"' then begin
                            inc(i);
                            while pari[i]<>'"' do
                            begin parCrt:=parCrt+pari[i];inc(i) end;
                            inc(i);
                            if pari[i]<>',' then paraEnd:=true;
                            inc(i);inString:=true;
                          end
                     else begin
                            while (pari[i]<>',') and (i<=length(pari)) do
                            begin parCrt:=parCrt+pari[i];inc(i) end;
                            if i>length(pari) then paraEnd:=true;
                            inc(i);inReal:=true;
                          end;
      { on passe systmatiquement les paramtres en chaines (meme si real ou expr) }
      pars[j]:=parCrt;
      { traitement si on a pas explicitement une chaine de caractres }
      if InReal
      then begin
          {type variable ou expression}
          if  (pos('@',parCrt)=0) and (pos('$',parCrt)=0) and (pos('#',parCrt)=0) then
          begin {type expression numerique}
             { on verifie que les paramtres ne sont pas des noms de spectres }
             vind1D:=und.indexof(parCrt);vind2D:=deuxd.indexof(parCrt);vind3D:=troisd.indexof(parCrt);
             if (vind1D=-1) and (vind2D=-1) and (vind3D=-1)
             then begin
                  parser1.expression:=parCrt;
                  par[j]:=parser1.value;
                  pars[j]:=floattostr(par[j]);
                  end;
          end;
          if pos('$',pars[j])>1 then
          begin {type variable string: nom$}
             nomvar:=copy(pars[j],1,pos('$',pars[j])-1);
             if variable.indexof(nomvar) <>-1 then
             pars[j]:=param[variable.indexof(nomvar)].p4;
          end;
          if pos('@',pars[j])=1 then
          begin {type adresse variable: @nom}
             nomvar:=copy(pars[j],2,length(pars[j]));
             pars[j]:=nomvar;
             if variable.indexof(nomvar)=-1 then addvariable(pars[1],0,0,0,0,'',tobject(@rien));
          end;
          if pos('#',pars[j])>1 then
          begin {type variable tableau: nom#indice}
             nomvar:=copy(pars[j],1,pos('#',pars[j])-1);
             parser1.expression:=copy(pars[j],pos('#',pars[j])+1,length(pars[j]));
             if variable.indexof(nomvar) <>-1 then
             begin
               par[j]:=param[variable.indexof(nomvar)].p5[round(parser1.value)];
               pars[j]:=floattostr(par[j]);
             end;
          end;
          end;
      inc(j); { passage au paramtre suivant }
      end
   end;

 @g:=ordre.Objects[ordre.indexof(s2)];
 g;
end;
end;
result:=retour;
end;


procedure Tinterpreteurform.FormClose(Sender: TObject; var Action: TCloseAction);
var
i:integer;
begin
actlig.free;
actligf.free;
variable.free;
varpar.free;
ordre.free;
for i:=1 to 200 do param[i].free;
end;

procedure Tinterpreteurform.Timer1Timer(Sender: TObject);
begin
{$IFDEF PILOTAGE }
if (flagwaitmotor) and (tabmot<>nil) then flagwaitmotor:=tabmot.onmov;
if (flagwaitacquis) and (suiviPRISMForm<>nil) then flagwaitacquis:=suiviPRISMForm.testacquis;
if (flagwaitacquis) and (comptage2DForm<>nil) then flagwaitacquis:=comptage2DForm.testacquis;
if (flagwaitacquis) and (comptage2DTOFForm<>nil) then flagwaitacquis:=comptage2DTOFForm.testacquis;
if (flagwaitacquisPSD) and (Comptage<>nil) then flagwaitacquisPSD:=comptage.testacquis;
if (flagwaitEnergizing) then flagwaitEnergizing:=testEnergizing;
{$ENDIF }

if (seqon>0)
and (not flagwaitchamp)
and (not flagwaitmotor)
and (not flagwaitacquis)
and (not flagwaitacquisPSD)
and (not flagwaitEnergizing)
then begin
 if (seqlig<actlig.count) and (seqlig>=0) then begin
 while ((copy(actlig.strings[seqlig],1,1)=';') or
 (copy(actlig.strings[seqlig],2,1)=';'))
  and (seqlig<actlig.count-1) do seqlig:=seqlig+1;
  interpreteurform.caption:='sq : '+actlig.strings[seqlig];
  seqlig:=traitstring(actlig.strings[seqlig],seqlig);
  SuiviDesVariablesForm.affiche;
  end else begin
  seqon:=0;timer1.enabled:=false;
  interpreteurform.caption:='pas de squence en cours';
  scriptStatus.caption:='Paused';
 end;
end;
end;

procedure Tinterpreteurform.suividevariable1Click(Sender: TObject);
begin
if not SuiviDesVariablesForm.visible then SuiviDesVariablesForm.show
else SuiviDesVariablesForm.visible:=false;
end;

procedure Tinterpreteurform.ScriptStopButtonClick(Sender: TObject);
begin
{$IFDEF PILOTAGE }
if suiviPRISMForm<>nil then suiviPRISMForm.stop;  { arret du comptage dans PrismForm }
if comptage2DTOFform<>nil then comptage2DTOFform.stop; { arret du comptage dans comptage2DTOFform }
if comptage2Dform<>nil then comptage2Dform.stop;   { arret du comptage dans comptage2Dform }
{$ENDIF }
seqon:=0;timer1.enabled:=false;
interpreteurform.caption:='pas de squence en cours';
scriptStatus.caption:='Paused';
end;

procedure Tinterpreteurform.ContinueButtonClick(Sender: TObject); { a tester }
begin
     seqon:=1;timer1.enabled:=true;
end;

procedure Tinterpreteurform.variables1Click(Sender: TObject);
begin
if not VariablesListeForm.visible then
begin
VariablesListeForm.affiche;VariablesListeForm.show;
end else VariablesListeForm.visible:=false;
end;

procedure Tinterpreteurform.fonctions1Click(Sender: TObject);
begin
if not functionslisteform.visible then
begin
functionslisteform.affiche;functionslisteform.show;
end else functionslisteform.visible:=false;
end;

procedure Tinterpreteurform.Parser1ParserError(Sender: TObject; E: Exception);
var
mt:array[0..30] of char;
begin
timer1.enabled:=false;strpcopy(mt,E.message);
messagebox(interpreteurform.handle,'erreur',mt,mb_ok);
end;

procedure Tinterpreteurform.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
toto:integer;
begin
if key=13 then begin
toto:=1;
if pos(';',edit1.text)<=0 then edit1.text:=edit1.text+';';
traitstring(edit1.text,toto);
SuiviDesVariablesForm.affiche;
end;
end;

procedure Tinterpreteurform.executeseq(name:string);
begin
mem1.activepage:=10;
mem1.Memo.Lines.LoadfromFile(name);
{$IFDEF PILOTAGE }
if suiviPRISMForm<>nil then suiviPRISMForm.stop;
{$ENDIF }
timer1.enabled:=false;
actligf.text:=mem1.memo.text;
pretraitement;
execution;
end;
end.




